<?php if(!defined('PLX_ROOT')) exit;
/**
 * PluXml Plugin adhesion
 *
 * @version	2.0.0
 * @date	23/10/2018
 * @author	Stephane F, Cyril MAGUIRE, Thomas Ingles
 **/
class adhesion extends plxPlugin {
	public $plxMotor;
	public $plxGlob_adherents;#Obj des données concernant les fichiers adhérents
	public $plxRecord_adherents;#Obj des données concernant les adhérents
	public $form_login_adherent;#Str mode du moteur & un formulaire seulement : form.login.inc.php

	public $oldAdherentsList = array();#Tableau des données des adhérents, extraites de la liste générée par l'ancienne version du plugin
	public $adherentsList = array();#Tableau des index des adhérents
	public $listsDiff = array();#Tableau des listes de diffusion
	public $listDiff = array();#La liste de diffusion des adhérents
	public $msg = FALSE;
	public $ok = FALSE;
#Paramètres des listes de diffusion Gutuma
	public $isGutumaActivated=false;
	public $GutumaListsDir;
	private $id;
	private $name;
	private $private;
	private $addresses;
	private $size;
#Paramètres de connexion
	private $ban = array();
	private $session_domain;

	/**
	 * Constructeur de la classe
	 *
	 * @param	default_lang	langue par défaut
	 * @return	stdio
	 * @author	Stephane F, Cyril MAGUIRE
	 **/
	public function __construct($default_lang) {

		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		# droits pour accèder à la page config.php du plugin
		$this->setConfigProfil(PROFIL_ADMIN);
		$this->setAdminProfil(PROFIL_ADMIN, PROFIL_MANAGER);

//ADMIN_MENU_TITLE
		if(defined('PLX_ADMIN'))// {#Déclaration des hooks pour la zone d'administration
			$this->setAdminMenu($this->getLang('L_ADMIN_MENU_NAME'), 1, $this->getLang('L_ADMIN_TITLE_MENU'));#Position du Menu : remplacer 0 par tout autre chiffre

		# déclaration des hooks
		$this->addHook('AdminPrepend', 'AdminPrepend');#Permet l'export de la liste des adhérents (opentbs)
		$this->addHook('AdminTopEndHead', 'AdminTopEndHead');#Affiche le js (jquery) et css du plugin dans la partie administration
		$this->addHook('AdminTopBottom', 'AdminTopBottom');#Affiche un message s'il y a un message à afficher
		$this->addHook('AdminAdhesionUsersFoot', 'AdminAdhesionUsersFoot');#hook admin.php Affiche le javascript dataTable
#		$this->addHook('AdminAdhesionUsersTop', 'AdminAdhesionUsersTop');#hook admin.php : OLD search : désactivé (dataTableIncHead() have searchs)
#		$this->addHook('AdminAdhesionUsersTopValid', 'AdminAdhesionUsersTopValid');#hook admin.php : OLD search : désactivé
		$this->addHook('plxMotorConstruct', 'plxMotorConstruct');#Méthode qui Récupére les données des adhérents : getAdherents()
		if(plxUtils::checkMail($this->getParam('email'))) {
			$this->addHook('plxMotorConstructLoadPlugins', 'plxMotorConstructLoadPlugins');#plxGlob_adherents qui mémorise le contenu du dossier adherents
			$this->addHook('plxMotorPreChauffageBegin', 'plxMotorPreChauffageBegin');#Met à jour la liste des adhérents de leur inscription, dès qu'une page publique est affichée & Page statique du formulaire d'adhésion
			$this->addHook('plxShowConstruct', 'plxShowConstruct');#Charge les infos des page statiques : $this->plxMotor->mode
			$this->addHook('plxShowStaticListEnd', 'plxShowStaticListEnd');#Gère l'affichage du menu des pages statiques du plugin
			$this->addHook('plxShowPageTitle', 'plxShowPageTitle');#Méthode qui renseigne le titre de la page dans la balise html <title> ONLY mode == 'adhesion' * Todo : adherer & annuaire(si:public)
			$this->addHook('ThemeEndHead', 'ThemeEndHead');#Ajoute le fichier css dans le fichier header.php du thème
			$this->addHook('ThemeEndBody', 'ThemeEndBody');#Affiche des messages succes/erreur
			$this->addHook('SitemapStatics', 'SitemapStatics');#Référence la page d'adhesion dans le sitemap * Todo : adherer & annuaire(si:public)
## déclaration des hooks pour sécuriser les articles
#index
			$this->addHook('AdminIndexTop', 'AdminIndexTop');#Enclanche la bufferisation de sortie pour afficher les cadenas (voir AdminIndexFoot())
			$this->addHook('AdminIndexFoot', 'AdminIndexFoot');#Affiche le cadenas au niveau de la page articles de l'administration si un article a un mot de passe
#article
			$this->addHook('AdminArticlePostData', 'AdminArticlePostData');#Ajoute le champ 'mot de passe' dans l'édition de l'article (Nouvelle cat article.php)
			$this->addHook('AdminArticleParseData', 'AdminArticleParseData');#Affiche l'icone si l'article est privé (cat ou lui même)
			$this->addHook('AdminArticleInitData', 'AdminArticleInitData');#Affiche l'icone si l'article est privé (cat ou lui même)
			$this->addHook('AdminArticleTop', 'AdminArticleTop');#Demarre la bufferisation de sortie sur la page admin/article.php
			$this->addHook('AdminArticleContent', 'AdminArticleContent');#Affiche l'icone si l'article est privé (cat ou lui même)
			$this->addHook('AdminArticleFoot', 'AdminArticleFoot');#Affiche une icone aux catégories dédiées aux adhérents (sidebar)
			$this->addHook('AdminArticleSidebar','AdminArticleSidebar');#Ajoute le champ 'mot de passe' dans l'édition de l'article
#plxAdmin
			$this->addHook('plxAdminEditArticleXml','plxAdminEditArticleXml');#Ajoute le champ 'mot de passe' dans l'édition de l'article
			$this->addHook('plxAdminEditCategoriesUpdate','plxAdminEditCategoriesUpdate');#Ajoute le champs 'mot de passe' dans les options des catégories
			$this->addHook('plxAdminEditCategoriesNew','plxAdminEditCategoriesNew');#Ajoute le champs 'mot de passe' dans les options des catégories, dans article.php
			$this->addHook('plxAdminEditCategoriesXml','plxAdminEditCategoriesXml');#Ajoute le champ 'mot de passe' dans l'édition de l'article
			$this->addHook('plxAdminEditCategorie','plxAdminEditCategorie');#Ajoute le champs 'mot de passe' dans les options des catégories
#cats
			$this->addHook('AdminCategory','AdminCategory');#Ajoute le champs 'mot de passe' dans les options des catégories
			$this->addHook('AdminCategoriesTop','AdminCategoriesTop');#Permet de démarrer la bufferisation de sortie sur la page admin/categories.php
			$this->addHook('AdminCategoriesFoot','AdminCategoriesFoot');#Affiche l'image du cadenas si la page est protégée par un mot de passe
#Moteur
			$this->addHook('plxMotorDemarrageBegin', 'plxMotorDemarrageBegin');#Permet la (dé)conexion en empechant de poster un commentaire (en mode article)
			$this->addHook('plxMotorPreChauffageEnd', 'plxMotorPreChauffageEnd');#Méthode qui redefinit les modes de plxMotor : art,homes,cat,tag&arch
			$this->addHook('plxMotorDemarrageEnd', 'plxMotorDemarrageEnd');#Affiche le formulaire de saisie du mot de passe
			$this->addHook('plxMotorParseArticle','plxMotorParseArticle');#Ajoute le champ 'mot de passe' dans l'édition de l'article
			$this->addHook('plxMotorGetCategories','plxMotorGetCategories');#Affiche le champs 'mot de passe' dans les options des catégories
#feed
			$this->addHook('plxFeedPreChauffageEnd','plxFeedPreChauffageEnd');#Permet de masquer s'il y a un mot de passe
			$this->addHook('plxFeedDemarrageBegin','plxFeedDemarrageBegin');#Permet d'afficher un article dans le flux RSS s'il n'est pas protégé par un mot de passe
#plug
#			$this->addHook('showIconIfLock','showIconIfLock');#UTILISÉ ? OUI
			$this->addHook('loginLogout','loginLogout');#Hook qui affiche le formulaire de cnx ou l'espace adhérent

## déclaration des hooks pour sécuriser les pages statiques
			$this->addHook('plxMotorGetStatiques', 'plxMotorGetStatiques');#Récupère la notification de mot de passe stockée dans le fichier xml statiques.xml
			$this->addHook('AdminStatic', 'AdminStatic');#Ajoute le champ de saisie du mot de passe dans la page d'édition de la page statique
			$this->addHook('plxAdminEditStatique', 'plxAdminEditStatique');#Récupère la notification de mot de passe saisit lors de l'édition de la page statique
			$this->addHook('plxAdminEditStatiquesXml', 'plxAdminEditStatiquesXml');#Ajoute la notification de mot de passe dans la chaine xml à sauvegarder dans statiques.xml
			$this->addHook('AdminStaticsTop', 'AdminStaticsTop');#Permet de démarrer la bufferisation de sortie sur la page admin/statiques.php
			$this->addHook('AdminStaticsFoot', 'AdminStaticsFoot');#Affiche l'image du cadenas si la page est protégée par un mot de passe

			$this->addHook('plxShowConstruct', 'plxShowConstructStat');#Protege les pages statiques si mode static_password : si page protégée url = static_password
			$this->addHook('plxMotorPreChauffageEnd', 'plxMotorPreChauffageEndStat');#Affiche le formulaire d'identification si un mot de passe est présent pour la page statique
			$this->addHook('plxMotorDemarrageEnd', 'plxMotorDemarrageEndStat');#Valide la connexion d'un adhérent
			$this->addHook('plxShowPageTitle', 'plxShowPageTitleStat');#Renseigne le titre de la page dans la balise html <title>
			$this->addHook('ThemeEndHead', 'ThemeEndHeadStat');#Ajoute le fichier style-lock.css dans le fichier header.php du thème
		}

		# On récupère l'ensemble des adhérents
		$this->plxGlob_adherents = plxGlob::getInstance(PLX_ROOT.$this->getParam('adherents').'adhesions',false,true,'arts');
		ksort($this->plxGlob_adherents->aFiles);
		$this->adherentsList = array_flip(array_keys($this->plxGlob_adherents->aFiles));
	}

	public function gutumaPlugin() {

		$this->isGutumaActivated = isset($this->plxMotor->plxPlugins->aPlugins['gutuma'])?$this->plxMotor->plxPlugins->aPlugins['gutuma']:null;
		if(is_object($this->isGutumaActivated)) {
			$this->isGutumaActivated = true;
			$htaccess = "Allow from none\n";
			$htaccess .= "Deny from all\n";
			$htaccess .= "<Files *.php>\n";
			$htaccess .= "order allow,deny\n";
			$htaccess .= "deny from all\n";
			$htaccess .= "</Files>\n";
			$htaccess .= "Options -Indexes\n";
			# Emplacement des listes de diffusion de Gutuma
			if ($this->plxMotor->plxPlugins->aPlugins['gutuma']->listsDir != null)
				$this->GutumaListsDir = $this->plxMotor->plxPlugins->aPlugins['gutuma']->listsDir;
			else
				$this->GutumaListsDir = PLX_ROOT.'data/gutuma';
			# Récupération des listes des anciennes versions de Gutuma
			if (is_dir(PLX_PLUGINS.'gutuma/news/lists')) {
				@rename(PLX_PLUGINS.'gutuma/news/lists', $this->GutumaListsDir);
				touch($this->GutumaListsDir.'/.htaccess');
				file_put_contents($this->GutumaListsDir.'/.htaccess', $htaccess);
			}
			# Récupération de la config des anciennes versions de Gutuma
			if (is_file(PLX_PLUGINS.'gutuma/news/inc/config.php')) {
				@mkdir($this->GutumaListsDir.'/inc');
				@rename(PLX_PLUGINS.'gutuma/news/inc/config.php', $this->GutumaListsDir.'/inc/config.php');
				touch($this->GutumaListsDir.'/inc/.htaccess');
				file_put_contents($this->GutumaListsDir.'/inc/.htaccess', $htaccess);
			}
			# On récupère les paramètres de la liste de diffusion
			$list = $this->getAllGutumaLists(TRUE);
			$k = 0;
			foreach ($list as $key => $value) {
				if ($value['name'] == 'adherents') {
					$k = $key;
				}
			}
			if (isset($list[$k])) {
				$this->id = $list[$k]['id'];
				$this->name = $list[$k]['name'];
				$this->private = $list[$k]['private'];
				$this->addresses = $list[$k]['addresses'];
				$this->listDiff = $list[$k]['addresses'];
			}

			if ($this->id != ''){
				$this->ok = TRUE;
			}

		}
	}

	///////////////////////////////////////////////////////////
	//
	// Méthodes permettant la mise en place du plugin
	//
	//////////////////////////////////////////////////////////

	/**
	 * plxGlob_adherents qui mémorise le contenu du dossier adherents
	 * @param	dir				repertoire à lire
	 * @param	rep				boolean pour ne prendre que les répertoires sans les fichiers
	 * @param	onlyfilename	boolean pour ne récupérer que le nom des fichiers sans le chemin
	 * @param	type			type de fichier lus (arts ou '')
	 * SI ($type=='arts') $index = str_replace('_','',substr($file, 0,strpos($file,'.'))); [initCache($type='')]
	 **/
	public function plxMotorConstructLoadPlugins() {
		echo '<?php ';?>
		$this->plxGlob_adherents = plxGlob::getInstance(PLX_ROOT.$this->plxPlugins->aPlugins['<?php echo __CLASS__?>']->getParam('adherents').'adhesions',false,true,'arts');
		$this->adherentsList = array_flip(array_keys($this->plxGlob_adherents->aFiles));
?><?php
	}

	/**
	 * Méthode qui Récupére les données des adhérents : getAdherents()
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxMotorConstruct() {
		echo '<?php ';?>
		$this->plxPlugins->aPlugins['<?php echo __CLASS__?>']->getAdherents('/^[0-9]{5}.(.[a-z-]+){2}.[0-9]{10}.xml$/');
?><?php
	}

	/**
	 * Méthode qui préconfigure le plugin
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function onActivate() {
		$plxAdmin = plxAdmin::getInstance();
		#Paramètres par défaut
		if(!is_file($this->plug['parameters.xml'])) {
			$this->setParam('adherents', 'data/configuration/', 'cdata');
			$this->setParam('mnuName', 'Devenir membre', 'string');
			$this->setParam('domaine_asso', plxUtils::strCheck($plxAdmin->aConf['racine']), 'string');
			$this->saveParams();
		}
		if (!is_dir(PLX_ROOT.$this->getParam('adherents').'adhesions')) {
			@mkdir(PLX_ROOT.$this->getParam('adherents').'adhesions');
		}
		# Si le fichier unique des adhérents existe (ancienne version), on le découpe
		if (is_file(PLX_ROOT.$this->getParam('adherents').'plugin.adhesion.adherents.xml')) {
			$this->genNewFilesFormOldData(PLX_ROOT.$this->getParam('adherents').'plugin.adhesion.adherents.xml');
		}
		if (isset($plxAdmin->plxPlugins->aPlugins["gutuma"])) {
			$listeDeDiffusion = plxUtils::strCheck($plxAdmin->aConf['title']);
			if ($listeDeDiffusion == '') {
				$listeDeDiffusion = 'Newsletters';
			}
			# On crée la liste de diffusion si elle n'existe pas
			if ($this->name != $listeDeDiffusion) {
				$this->listDiff = $this->createGutumaList($listeDeDiffusion);
			}
		}
		//Si les plugins lockArticles et plxMyPrivateStatic sont activés, on les désactive
		if (isset($plxAdmin->plxPlugins->aPlugins["lockArticles"])) {
			$content['selection'] ='deactivate';
			$content['plugName'] = array('lockArticles'=>'on');
			$content['action']['lockArticles'] = 'on';
			$plxAdmin->plxPlugins->saveConfig($content);
		}
		if (isset($plxAdmin->plxPlugins->aPlugins["plxMyPrivateStatic"])) {
			$content['selection'] ='deactivate';
			$content['plugName'] = array('plxMyPrivateStatic'=>'on');
			$content['action']['plxMyPrivateStatic'] = 'on';
			$plxAdmin->plxPlugins->saveConfig($content);
		}
	}

	/**
	 * Méthode qui récupère les infos enregistrées dans le fichier data/configuration/plugin.adhesion.adherents.xml
	 *
	 * @param $filename ressource le chemin vers le fichier des adhérents
	 * @return array
	 *
	 * @author Cyril MAGUIRE
	 */
	private function getAdherentsFromOldFile($filename) {

		if(!is_file($filename)) return;

		# Mise en place du parseur XML
		$data = implode('',file($filename));
		$parser = xml_parser_create(PLX_CHARSET);
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$values,$iTags);
		xml_parser_free($parser);
		if(isset($iTags['adherent']) AND isset($iTags['nom'])) {
			$nb = sizeof($iTags['nom']);
			$size=ceil(sizeof($iTags['adherent'])/$nb);
			for($i=0;$i<$nb;$i++) {
				$attributes = $values[$iTags['adherent'][$i*$size]]['attributes'];
				$number = $attributes['number'];
				# Recuperation du nom
				$this->oldAdherentsList[$number]['nom']=plxUtils::getValue($values[$iTags['nom'][$i]]['value']);
				# Recuperation du prenom
				$this->oldAdherentsList[$number]['prenom']=plxUtils::getValue($values[$iTags['prenom'][$i]]['value']);
				# Recuperation de l'adresse 1
				$this->oldAdherentsList[$number]['adresse1']=plxUtils::getValue($values[$iTags['adresse1'][$i]]['value']);
				# Recuperation de l'adresse 2
				$this->oldAdherentsList[$number]['adresse2']=plxUtils::getValue($values[$iTags['adresse2'][$i]]['value']);
				# Recuperation du code postal
				$this->oldAdherentsList[$number]['cp']=plxUtils::getValue($values[$iTags['cp'][$i]]['value']);
				# Recuperation de la ville
				$this->oldAdherentsList[$number]['ville']=plxUtils::getValue($values[$iTags['ville'][$i]]['value']);
				# Recuperation du téléphone
				$this->oldAdherentsList[$number]['tel']=plxUtils::getValue($values[$iTags['tel'][$i]]['value']);
				# Recuperation du mail
				$this->oldAdherentsList[$number]['mail']=plxUtils::getValue($values[$iTags['mail'][$i]]['value']);
				# Recuperation du choix quant à l'adhésion
				$this->oldAdherentsList[$number]['choix']=plxUtils::getValue($values[$iTags['choix'][$i]]['value']);
				# Recuperation du choix pour le mailing
				$this->oldAdherentsList[$number]['mailing']=plxUtils::getValue($values[$iTags['mailing'][$i]]['value']);
				# Recuperation du statut de l'adhérent
				$this->oldAdherentsList[$number]['validation']=plxUtils::getValue($values[$iTags['validation'][$i]]['value']);
				# Recuperation de la date de première adhésion
				$this->oldAdherentsList[$number]['firstDate']=plxUtils::getValue($values[$iTags['firstDate'][$i]]['value']);
				# Recuperation de la date de validation de l'adhésion
				$this->oldAdherentsList[$number]['date']=plxUtils::getValue($values[$iTags['date'][$i]]['value']);
				# Recuperation de la chaine salt de l'adhérent
				$this->oldAdherentsList[$number]['salt']=plxUtils::getValue($values[$iTags['salt'][$i]]['value']);
				# Recuperation du mot de passe cripté de l'adhérent
				$this->oldAdherentsList[$number]['password']=plxUtils::getValue($values[$iTags['password'][$i]]['value']);
				# Recuperation de la clé
				$this->oldAdherentsList[$number]['cle']=plxUtils::getValue($values[$iTags['cle'][$i]]['value']);
				# Recuperation des chaines aléatoires
				$this->oldAdherentsList[$number]['rand1']=plxUtils::getValue($values[$iTags['rand1'][$i]]['value']);
				$this->oldAdherentsList[$number]['rand2']=plxUtils::getValue($values[$iTags['rand2'][$i]]['value']);
				if ($this->getParam('typeAnnuaire') == 'professionnel') {
					# Recuperation de l'activité
					$this->oldAdherentsList[$number]['activite']=plxUtils::getValue($values[$iTags['activite'][$i]]['value']);
					# Recuperation de l'établissement
					$this->oldAdherentsList[$number]['etablissement']=plxUtils::getValue($values[$iTags['etablissement'][$i]]['value']);
					# Recuperation du service
					$this->oldAdherentsList[$number]['service']=plxUtils::getValue($values[$iTags['service'][$i]]['value']);
					# Recuperation du poste
					$this->oldAdherentsList[$number]['tel_office']=plxUtils::getValue($values[$iTags['tel_office'][$i]]['value']);
				}
				if ($this->getParam('showAnnuaire') == 'on') {
					# Recuperation du choix sur le partage des coordonnées
					$this->oldAdherentsList[$number]['coordonnees']=plxUtils::getValue($values[$iTags['coordonnees'][$i]]['value']);
				}
			}
		}
		//tri du tableau par ordre alphabétique des noms
		$tmp = array();
		foreach($this->oldAdherentsList as $id=>$v){
			$tmp[$v["nom"]] = array(
				'id'=>$id,
				'details'=>$v
			);
		}
		ksort($tmp);
		$this->oldAdherentsList = array();
		foreach ($tmp as $nom => $value) {
			$this->oldAdherentsList[$value['id']] = $value['details'];
		}
		return $this->oldAdherentsList;
	}

	private function genNewFilesFormOldData($filename) {

		$this->getAdherentsFromOldFile($filename);

		foreach ($this->oldAdherentsList as $id => $adherent) {
			$fileName = $id.'.'.plxUtils::title2filename($adherent['nom'].'.'.$adherent['prenom']).'.'.(empty($adherent['firstDate'])? time() : $adherent['firstDate']).'.xml';
			# On génére le fichier XML
			$xml = "<?xml version=\"1.0\" encoding=\"".PLX_CHARSET."\"?>\n";
			$xml .= "<document>\n";
				$xml .= "\t<adherent number=\"".$id."\">\n\t\t";
				$xml .= "<nom><![CDATA[".plxUtils::cdataCheck($adherent['nom'])."]]></nom>\n\t\t";
				$xml .= "<prenom><![CDATA[".plxUtils::cdataCheck($adherent['prenom'])."]]></prenom>\n\t\t";
				$xml .= "<adresse1><![CDATA[".plxUtils::cdataCheck($adherent['adresse1'])."]]></adresse1>\n\t\t";
				$xml .= "<adresse2><![CDATA[".plxUtils::cdataCheck($adherent['adresse2'])."]]></adresse2>\n\t\t";
				$xml .= "<cp><![CDATA[".plxUtils::cdataCheck($adherent['cp'])."]]></cp>\n\t\t";
				$xml .= "<ville><![CDATA[".plxUtils::cdataCheck($adherent['ville'])."]]></ville>\n\t\t";
				$xml .= "<tel><![CDATA[".plxUtils::cdataCheck($adherent['tel'])."]]></tel>\n\t\t";
				$xml .= "<mail><![CDATA[".plxUtils::cdataCheck($adherent['mail'])."]]></mail>\n\t\t";
				$xml .= "<choix><![CDATA[".plxUtils::cdataCheck($adherent['choix'])."]]></choix>\n\t\t";
				$xml .= "<mailing><![CDATA[".plxUtils::cdataCheck($adherent['mailing'])."]]></mailing>\n\t\t";
				$xml .= "<salt><![CDATA[".plxUtils::cdataCheck($adherent['salt'])."]]></salt>\n\t\t";
				$xml .= "<password><![CDATA[".plxUtils::cdataCheck($adherent['password'])."]]></password>\n\t\t";
				$xml .= "<rand1><![CDATA[".plxUtils::cdataCheck($adherent['rand1'])."]]></rand1>\n\t\t";
				$xml .= "<rand2><![CDATA[".plxUtils::cdataCheck($adherent['rand2'])."]]></rand2>\n\t\t";
				$xml .= "<cle><![CDATA[".plxUtils::cdataCheck($adherent['cle'])."]]></cle>\n\t\t";
				$xml .=	"<validation>".plxUtils::cdataCheck($adherent['validation'])."</validation>\n\t\t";
				$xml .=	"<firstDate>".plxUtils::cdataCheck($adherent['firstDate'])."</firstDate>\n\t\t";
				$xml .=	"<date>".plxUtils::cdataCheck($adherent['date'])."</date>\n\t\t";
				if ($this->getParam('typeAnnuaire') == 'professionnel') {
				$xml .= "<activite><![CDATA[".plxUtils::cdataCheck($adherent['activite'])."]]></activite>\n\t\t";
				$xml .= "<etablissement><![CDATA[".plxUtils::cdataCheck($adherent['etablissement'])."]]></etablissement>\n\t\t";
				$xml .= "<service><![CDATA[".plxUtils::cdataCheck($adherent['service'])."]]></service>\n\t\t";
				$xml .= "<tel_office><![CDATA[".plxUtils::cdataCheck($adherent['tel_office'])."]]></tel_office>\n\t";
				}
				if ($this->getParam('showAnnuaire') == 'on') {
				$xml .= "\t<coordonnees><![CDATA[".plxUtils::cdataCheck($adherent['coordonnees'])."]]></coordonnees>\n\t";
				}
				$xml .= "</adherent>\n";
			$xml .= "</document>";
			# On écrit le fichier
			if(!plxUtils::write($xml, PLX_ROOT.$this->getParam('adherents').get_class($this).'/'.$fileName)) {
				$_SESSION['error'] = $this->getLang('L_WARNPRM_ADHERENTS').'<br/>' ;
				break;
			}
		}
	}


	/**
	 * Méthode qui Charge les infos d'une des pages statiques : plxMotor->mode
	 *
	 * @return	stdio
	 * @author	Stephane F, Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxShowConstruct() {
		echo '<?php '; ?>
			$nomMnu = '';
			switch($this->plxMotor->mode){
				case 'login-page':
					$nomMnu = '<?php $this->lang('L_FORM_LOGIN') ?>';
					break;
				case 'adhesion':
					$nomMnu = '<?php echo $this->getParam('mnuName') ?>';
					break;
				case 'adherer':
					$nomMnu = '<?php echo $this->getParam('mnuAdherer') ?>';
					break;
				case 'forgetmypass':
					$nomMnu = '<?php echo $this->getParam('mnuForgetMyPass') ?>';
					break;
				case 'annuaire':
					$nomMnu = '<?php echo $this->getParam('mnuAnnuaire') ?>';
					break;
				case 'myaccount':
					$nomMnu = '<?php echo $this->getParam('mnuMyAccount') ?>';
					break;
//				default:return;#MEMO,plxShowConstruct NEVER RETURN, lock other static plugs & more
			}
			if(!empty($nomMnu)){
				$array = array();
				$array[$this->plxMotor->cible] = array(
					'name'		=> $nomMnu,
					'menu'		=> '',//oui
					'url'		=> $this->plxMotor->mode.'.html',
					'readable'	=> 1,
					'active'	=> 1,
					'group'		=> ''//grp name
				);
				$this->plxMotor->aStats = array_merge($this->plxMotor->aStats, $array);
				return;
			}
?><?php
	}

	/**
	 * Méthode de traitement du hook plxMotorPreChauffageBegin
	 * 1) On met à jour la liste des adhérents, en fonction de la date de leur inscription, dès qu'une page publique est affichée
	 * 2) On utilise une page statique pour afficher le formulaire d'adhésion
	 *
	 * @return	stdio
	 * @author	Stephane F, Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxMotorPreChauffageBegin() {
		$this->plxMotor = plxMotor::getInstance();//$_SESSION
		$this->gutumaPlugin();
		$content = array();//echo strtotime("20 October 2011");exit();
		if(isset($this->plxRecord_adherents->result)){//chron by user
			foreach ($this->plxRecord_adherents->result as $i => $value) {
				if ($value['validation'] == '1') {
					if ($this->getParam('annee') == 'civile') {
						$datetimeOld = date('Y',$value['date']);
						//(60*60*24*365) = 31536000 secondes soit 1 an
						$datetimeNew = strtotime('01 January '.($datetimeOld+1).' 00:00:01' );
					}
					if ($this->getParam('annee') == 'entiere') {
						$datetimeOld = $value['date'];
						$datetimeNew = $datetimeOld+365*24*60*60;//(60*60*24*365) = 31536000 secondes soit 1 an
					}
					if ( $datetimeNew < time() ){
						foreach ($value as $key => $v) {
							$content[$key.'_'.$value['id']] = $v;
						}
						$content['validation_'.$value['id']] = '0';
						$content['idAdherent'] = array($value['id']);
						$this->editAdherentslist($content,$value['id'],TRUE);
					}
				}
			}
		}

		$template = $this->getParam('template')==''?'static.php':$this->getParam('template');
		$cible = (defined('PLX_MYMULTILINGUE')?'../':'').'../../'.PLX_PLUGINS.__CLASS__.'/form';
		$pagesAccount = array('login-page','adhesion','adherer','myaccount','forgetmypass','annuaire');
		$string = "
		if(\$this->get) {".PHP_EOL;
		foreach($pagesAccount as $page){
			$string .= "
			if(preg_match('/^".$page."\/?/',\$this->get)) {
				\$this->mode = '".$page."';
				\$this->cible = '".$cible."';
				\$this->template = '".$template."';
				return TRUE;
			}".PHP_EOL;
  }
		$string .= "
		}".PHP_EOL;
		echo "<?php ".$string." ?>";
	}

	/**
	 * Méthode qui Gère l'affichage du menu des pages statiques du plugin
	 *
	 * @return	stdio
	 * @author	Stephane F, Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxShowStaticListEnd() {
		echo '<?php '; ?>
		$class = 'noactive';//($this->plxMotor->mode=='adhesion' || $this->plxMotor->mode=='adherer' || $this->plxMotor->mode=='annuaire')?'active':'noactive';
		$class1 = $this->plxMotor->mode=='adhesion'?'active':'noactive';
		$class2 = $this->plxMotor->mode=='adherer'?'active':'noactive';
		$class3 = $this->plxMotor->mode=='annuaire'?'active':'noactive';
		$annuaire = '';
<?php
		if($this->getParam('mnuDisplay')) {# ajout du menu d'accès  && $this->getParam('publicAnnuaire') == 'on'
			if($this->getParam('showAnnuaire') != 'no') :
?>
				$annuaire = '
  <li id="static-adhesion" class="static menu '.$class3.'">
   <a href="<?php echo $this->plxMotor->urlRewrite('?annuaire.html') ?>" title="<?php echo $this->getParam('mnuAnnuaire') ?>"><?php echo $this->getParam('mnuAnnuaire') ?></a>
  </li>';
<?php
			endif;//showAnnuaire
			if(!isset($_SESSION['account'])) {#si l'utilisateur n'est pas connecté :à la page d'adhesion
				if($this->getParam('publicAnnuaire') == 'no') {#on désactive l'annuaire si privé ?>
					$annuaire = '';
<?php
				}//fi publicAnnuaire
?>
				array_splice($menus, <?php echo ($this->getParam('mnuPos')-1) ?>, 0, '
<li id="static-adhesion" class="menu-item '.$class.'">
 <span class="menu-item static group '.$class.'"><?php echo $this->getParam('mnuName') ?></span>
 <ul id="static-adhesion-guest">
  <li class="static menu '.$class2.'">
   <a href="'.$this->plxMotor->urlRewrite('?adherer.html').'" title="<?php echo $this->getParam('mnuAdherer') ?>"><?php echo $this->getParam('mnuAdherer') ?></a>
  </li>
  <li class="static menu '.$class1.'">
   <a href="'.$this->plxMotor->urlRewrite('?adhesion.html').'" title="<?php echo $this->getParam('mnuAdhesion') ?>"><?php echo $this->getParam('mnuAdhesion') ?></a>
  </li>'.$annuaire.'
  <li class="static menu noactive">
   <a href="'.$this->plxMotor->urlRewrite('?login-page.html').'" title="<?php $this->lang('L_FORM_LOGIN') ?>"><?php $this->lang('L_FORM_LOGIN') ?></a>
  </li>
 </ul>
</li>'.PHP_EOL);
<?php
			}// fi guest menu
		 if (isset($_SESSION['account'])){#L'utilisateur est connecté
?>				array_splice($menus, <?php echo ($this->getParam('mnuPos')-1) ?>, 0, '
<li id="static-adhesion" class="menu-item '.$class.'">
 <span class="menu-item static group '.$class.'"><?php $this->lang('L_FORM_MEMBERS') ?></span>
 <ul id="static-adhesion-account">'.$annuaire.'
  <li class="static menu '.$class2.'">
   <a href="'.$this->plxMotor->urlRewrite('?myaccount.html').'" title="<?php $this->lang('L_MY_ACCOUNT') ?>"><?php $this->lang('L_MY_ACCOUNT') ?></a>
  </li>
  <li class="static menu '.$class1.'">
   <form action="" method="post" id="logout"><input type="hidden" name="logout"><input type="submit" value="<?php $this->lang('L_FORM_LOGOUT')?>" id="sub"/></form>
  </li>
 </ul>
</li>'.PHP_EOL);
<?php
			}
		}//fi mnuDisplay
echo ' ?>';
	}

	/**
	 * Méthode qui inclus dataTable (balise css & js) (ThemeEndHead et AdminTopEndHead)
	 *
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function dataTableIncHead($w=false) {//cdn idée
		$v = PLX_PLUGINS.__CLASS__.'/js/Vanilla-DataTables/vanilla-dataTables.min.';//https://github.com/Mobius1/Vanilla-DataTables/pull/65 & jscompress.com
		if($w)
			$v = $w;
?>
	<link rel="stylesheet" type="text/css" href="<?php echo $v ?>css?v=1.6.14" media="screen" />
	<script type="text/javascript" src="<?php echo $v ?>js?v=1.6.14"></script>
<?php
	}

	/**
	 * Méthode qui ajoute le fichier css dans le fichier header.php du thème
	 *
	 * @return	stdio
	 * @author	Stephane F, Cyril MAGUIRE, Thomas I.
	 **/
	public function ThemeEndHead() {
		$css = "\t".'<link rel="stylesheet" type="text/css" href="'.PLX_PLUGINS.__CLASS__.'/style.css" media="screen" />'.PHP_EOL;
		switch($this->plxMotor->mode) {
			case "annuaire":
				$this->dataTableIncHead();
//tags,home,tags_password,static_password,article_password,categorie_password,categories_password,adhesion,myaccount,forgetmypass//adherer
			default:
				echo $css;
				if(!isset($_SESSION['lockArticles']));// return;//strpos($this->plxMotor->mode,'_password') === false; not annuary
?>	<style type="text/css">#wall-e{position:absolute;left:-99999px;}</style><?php
		}
	}

	/**
	 * Méthode qui renseigne le titre de la page dans la balise html <title>
	 *
	 * @return	stdio
	 * @author	Stephane F, Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxShowPageTitle() {
		echo '<?php ';?>
			switch($this->plxMotor->mode) {
				case 'login-page':
					echo plxUtils::strCheck($this->plxMotor->aConf['title'].' - <?php $this->lang('L_FORM_LOGIN') ?>');
					return TRUE;
				case 'adhesion':
					echo plxUtils::strCheck($this->plxMotor->aConf['title'].' - <?php echo $this->getParam('mnuName') ?>');
					return TRUE;
				case 'adherer':
					echo plxUtils::strCheck($this->plxMotor->aConf['title'].' - <?php echo $this->getParam('mnuAdherer') ?>');
					return TRUE;
				case 'annuaire':
					echo plxUtils::strCheck($this->plxMotor->aConf['title'].' - <?php echo $this->getParam('mnuAnnuaire') ?>');
					return TRUE;
				case 'myaccount':
					echo plxUtils::strCheck($this->plxMotor->aConf['title'].' - <?php echo $this->getParam('mnuMyAccount') ?>');
					return TRUE;
				case 'forgetmypass':
					echo plxUtils::strCheck($this->plxMotor->aConf['title'].' - <?php echo $this->getParam('mnuForgetMyPass') ?>');
					return TRUE;
#				default:
#					echo plxUtils::strCheck($this->plxMotor->aConf['title'].' - '.$this->plxMotor->mode);
#					return TRUE;
			}
?><?php
	}

	/**
	 * Méthode qui référence la page d'adhesion dans le sitemap
	 * Note : annuaire(si:public) : todo : adherer?
	 * @return	stdio
	 * @author	Stephane F, Cyril MAGUIRE, Thomas Ingles
	 **/
	public function SitemapStatics() {
		foreach(array(get_class($this), ($this->getParam('publicAnnuaire')!='no'?'annuaire':false)) AS $statUrl):
			if (!$statUrl) continue;
?>
	<url>
		<loc><?php echo $this->plxMotor->urlRewrite('?'.$statUrl.'.html') ?></loc>
		<changefreq>monthly</changefreq>
		<priority>0.8</priority>
	</url>
<?php
endforeach;
	}

	/**
	 * Méthode permettant l'export de la liste des adhérents
	 *
	 * @return void
	 * @author Cyril MAGUIRE
	 */
	public function AdminPrepend() {
		$this->plxMotor = plxAdmin::getInstance();
		$this->gutumaPlugin();
		# Impression de la liste des adhérents
		if (isset($_GET['print'])) {
			$this->getAdherents('/^[0-9]{5}.(.[a-z-]+){2}.[0-9]{10}.xml$/');
			# Inclusion des librairies de TBS
			if (version_compare(PHP_VERSION,'5')<0) {
				include_once 'opentbs/tbs_class.php'; // TinyButStrong template engine
			} else {
				include_once 'opentbs/tbs_class_php5.php'; // TinyButStrong template engine
			}
			if (($_GET['print'] == 'xls') ) {
				include_once 'opentbs/tbs_plugin_excel.php'; // Excel plugin
			} else {
				include_once 'opentbs/tbs_plugin_opentbs.php'; // OpenTBS plugin
			}
			include_once 'print.php';
			exit();
		}
	}

	/**
	 * Méthode qui affiche le js et css du plugin de ses parties administratives
	 * [parametres_]plugin.php ok
	 * @author Cyril MAGUIRE, Stephane F
	 */
	public function AdminTopEndHead() {
		$bn = basename($_SERVER['SCRIPT_NAME']);
		$ok = ($bn=='plugin.php'||$bn=='parametres_plugin.php')&&(isset($_GET['p']) && $_GET['p']==__CLASS__);
		if($ok) {
?>
	<link rel="stylesheet" type="text/css" href="<?php echo PLX_PLUGINS.__CLASS__ ?>/style-admin.css" media="screen" />
	<link rel="stylesheet" type="text/css" href="<?php echo PLX_PLUGINS.__CLASS__ ?>/style.css" media="screen" />
	<script type="text/javascript">
/* <![CDATA[ */
		if (typeof jQuery == 'undefined') {
			document.write('<script type="text\/javascript" src="<?php echo PLX_PLUGINS.__CLASS__ ?>\/js\/jquery.min.js?v=3.2.1"><\/script>');
		}
/* ]]> */
	</script>
<?php
			$this->dataTableIncHead();//cdn ou jquery:::PLX_PLUGINS.__CLASS__.'/js/jquery-DataTables/datatables.min.' ::: AdminAdhesionUsersFoot()
		}
	}

	/**
	 * Méthode de traitement du hook AdhesionUserTop ::: OLD
	 *
	 * @return	stdio
	 * @author	Stephane F
	 **/
	public function AdminAdhesionUsersTop() {
?>
		<p class="hide" style="display:none;text-align:right">
			<?php $this->lang('L_LABEL_FIND') ?>&nbsp;:&nbsp;
			<input type="text" id="txtFilter" name="txtFilter" />&nbsp;
			<img style="display:none" id="imgDeleteFilter" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/cancel.gif" alt="<?php $this->lang('L_LABEL_DELETE_FILTER') ?>" title="<?php $this->lang('L_LABEL_DELETE_FILTER') ?>" />
		</p>
<?php
	}
	/**
	 * Méthode de traitement du hook AdhesionUserTopValid ::: OLD
	 *
	 * @return	stdio
	 * @author	Stephane F
	 **/
	public function AdminAdhesionUsersTopValid() {
?>
		<p class="hide" style="display:none;text-align:right">
			<?php $this->lang('L_LABEL_FIND') ?>&nbsp;:&nbsp;
			<input type="text" id="txtFilterV" name="txtFilterV" />&nbsp;
			<img style="display:none" id="imgDeleteFilterV" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/cancel.gif" alt="<?php $this->lang('L_LABEL_DELETE_FILTER') ?>" title="<?php $this->lang('L_LABEL_DELETE_FILTER') ?>" />
		</p>
<?php
	}

	/**
	 * hook admin.php Affiche le javascript dataTable
	 * DataTable js + Chercher Adhérent(e)s
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminAdhesionUsersFoot() {
?>
<script type="text/javascript">
/* <![CDATA[ */
for(var dt=0; dt<2; dt++){
	var dataTable = new DataTable("#table"+dt, {
		searchable: true,
		fixedHeight: false,
		perPageSelect: [5, 10, 15, 20, 25, 50, 100],
		// Customise the display text
		labels: {
			placeholder: "<?php $this->lang('L_LABEL_JSDTABLE_PLACEHOLDE') ?>", // The search input placeholder
			perPage: "<?php $this->lang('L_LABEL_JSDTABLE_PERPGS') ?>", // per-page dropdown label
			noRows: "<?php $this->lang('L_LABEL_JSDTABLE_NODATA') ?>", // Message shown when there are no search results
			info: "<?php $this->lang('L_LABEL_JSDTABLE_INFO') ?>", //Showing {start} to {end} of {rows} entries
		}
	});
}
dataTable.on('datatable.init',function(){autres();});
dataTable.on('datatable.sort',function(column, direction){autres();});
//~ dataTable.on('datatable.perpage',function(perpage){});
//~ clrSrch = document.createElement("span");
//~ clrSrch.innerHTML = '<img src="<?php echo PLX_PLUGINS.__CLASS__ ?>/cancel.gif" alt="<?php $this->lang('L_LABEL_DELETE_FILTER') ?>" title="<?php $this->lang('L_LABEL_DELETE_FILTER') ?>" />';
//~ dataTable.on('datatable.search',function(query, matched){);
function autres(){//datatable.init & datatable.sort
	var other_activity = window.document.getElementsByClassName('autre');
	for(var a = 0;a < other_activity.length; a++){
		var i = other_activity[a].id.replace(/_autre/,'');
		var sel_activity = window.document.getElementById(i);
		if(sel_activity.value!='autre')other_activity[a].style.display='none';//fix old chromium
	}
}
function activite_new(e){//onchange
	var i = e.id.replace(/activite/,'activite_autre');
	var other = window.document.getElementById(i);
	if(e.value!='autre'){other.style.display='none;';}
	else{other.style.display='';other.focus();/*activite_evnt(e,'focus');*/}
}
function activite_evnt(e,o){//on(focus|blur)
//console.log('activite_evnt',e,o);
	if(o=='blur'){e.value = e.value?e.value:'<?php $this->lang('L_ADMIN_NOT_DONE') ?>';}
	else{e.value = e.value!='<?php $this->lang('L_ADMIN_NOT_DONE') ?>'?e.value:'';}
}
function choice(e){//onchange
	if (e.value == 'stop'){
		if(!confirm('<?php $this->lang('L_ADMIN_CONFIRM') ?>'))
			e.value = 'adhesion';
		else
			e.className = e.className+' stop';
	}else{
		e.className = e.className.replace(/ stop/,'');
	}
}
function adherentsVerif(i){//admin.php
 if(s=='false') return false;
 var s = window.document.getElementById('id_selection'+i).value;//false, (de)validation, update, delete
 var a = window.document.getElementsByName('idAdherent[]');
 var ok = false;
 var e = 0;
 while(e<a.length){
  if(a[e].form.id == 'form'+i){
   if(a[e].checked){
    ok = true;
    break;
   }
  }
  e = e + 1;
 }
 if (!ok) return false;

 if(s=='devalidation')
  return confirm('<?php $this->lang('L_ADMIN_LIST_DEVALIDATION')?>');
 if(s=='delete')
  return confirm('<?php $this->lang('L_ADMIN_DELETE')?>');
}
/* ]]> */
</script>
<?php
	}

	/**
	 * Méthode qui affiche un message s'il y a un message à afficher
	 *
	 * @return	stdio
	 * @author	Stephane F, Cyril MAGUIRE, Thomas Ingles
	 **/
	public function AdminTopBottom() {
		echo '<?php '; ?>
		$nomgrf = "<?php echo get_class($this); ?>";
		$greffe = $plxAdmin->plxPlugins->aPlugins[$nomgrf];
		$nomgrf = '<a href="parametres_plugin.php?p='.$nomgrf.'#id_%s">Plugin '.$nomgrf.'%s</a>&nbsp;:&nbsp;';
		if($greffe->isGutumaActivated) {
			if(!$greffe->ok) {
				echo '<p class="notice warning">'.sprintf($nomgrf,'gutuma','').'<?php $this->lang('L_WARNPRM_NO_GULIST') ?></p>';
				plxMsg::Display();
			}
		}
		$tstPrm = array('email', 'nom_asso', 'adresse_asso', 'adherents');
		foreach($tstPrm AS $prm){
			if($greffe->getParam($prm)=="") {
				echo '<p class="warning">'.sprintf($nomgrf,$prm,' config').$greffe->getLang('L_WARNPRM_'.strtoupper($prm)).'</p>';
				plxMsg::Display();
			}
		}
		$tstPrm = array('subject', 'desc_adhesion', 'validation_subject', 'devalidation_subject', 'thankyou', 'subject_password');
		foreach($tstPrm AS $prm){
			if($greffe->getParam($prm)=="" OR $greffe->getParam($prm)==str_replace("'","’",$greffe->getLang('L_DEFAULT_'.strtoupper($prm)))) {
				$hprm = str_replace('desc_adhesion','mnuAdhesion',$prm);#desc_adhesion hidden hack
				echo '<p class="notice warning">'.sprintf($nomgrf,$hprm,' config').$greffe->getLang('L_WARNPRM_'.strtoupper($prm)).'</p>';
				plxMsg::Display();
			}
		}

		if(trim(strip_tags(htmlspecialchars_decode($greffe->getParam('desc_adhesion'))))==str_replace("'","’",$greffe->getLang('L_DEFAULT_DESC'))) {
			echo '<p class="notice warning">'.sprintf($nomgrf,'mnuAdhesion',' config').$greffe->getLang('L_WARNPRM_DESC_ADHESION').'</p>';#desc_adhesion hidden hack
			plxMsg::Display();
		}

		if (!is_dir(PLX_ROOT.$greffe->getParam('adherents').'adhesions')) {
			echo '<p class="warning">'.sprintf($nomgrf,'adherents',' config').$greffe->getLang('L_WARNPRM_NO_DIR_ADHES').'</p>';
			plxMsg::Display();
		}
		unset($greffe,$nomgrf,$prm,$tstPrm);
?><?php
	}

	/**
	 * Méthode qui inverse la position des lettres composant un email afin d'éviter les spams
	 *
	 * @param email string l'email à obfusquer
	 * @return string
	 *
	 * @author Cyril MAGUIRE
	 */
	public function badEmail($email) {
		//$email = str_replace(array('@','.'),array('[AT]','[DOT]'),$email);
		$longueur = strlen(trim($email));
		for ($i=1; $i < $longueur+1 ; $i++) {
			$tmp[$i] = $email[$longueur-$i];
		}
		$email = implode('', $tmp);
	 	return '<span onClick="joindre(this.textContent);" class="baddirection">'.str_replace(array('@','.'),array('_[TA]_','_[TOD]_'),$email).'</span>';
	}

	/**
	 * Méthode d'envoi de mail
	 *
	 * @param	name		string 			Nom de l'expéditeur
	 * @param	from		string 			Email de l'expéditeur
	 * @param	to			array/string	Adresse(s) du(des) destinataires(s)
	 * @param	subject		string			Objet du mail
	 * @param	body		string			Contenu du mail
	 * @param	contentType	string			Format du mail : txt ou html
	 * @param	cc			array			Les destinataires en copie
	 * @param	bcc			string			Les destinataires en copie
	 * @return				boolean			renvoie FAUX en cas d'erreur d'envoi
	 * @author	Cyril MAGUIRE
	 */
	public function sendEmail($name, $from, $to, $subject, $body, $contentType="html", $cc=FALSE, $bcc=FALSE) {
//return TRUE;//preseve free in dev Warning: mail(): connect() failed: Connection refused  && Warning: mail(): mail server down
		$eBody  = "<html><head><title>'.$subject.'</title></head><body style=\"margin:10px;\">".$body;
		$eBody .= "-----------<br />";
		$eBody .= $this->getParam('nom_asso')."</body></html>";

		if(is_array($to))
			$to = implode(', ', $to);
		if(is_array($cc))
			$cc = implode(', ', $cc);
		if(is_array($bcc))
			$bcc = implode(', ', $bcc);

		$headers  = "From: ".$name." <".$this->getParam('email').">\r\n";
		$headers .= "Reply-To: no-reply@".$this->getParam('domaine_asso')."\r\n";
		$headers .= 'MIME-Version: 1.0'."\r\n";
		// Content-Type
		if($contentType == 'html')
			$headers .= 'Content-type: text/html; charset="'.PLX_CHARSET.'"'."\r\n";
		else
			$headers .= 'Content-type: text/plain; charset="'.PLX_CHARSET.'"'."\r\n";

		$headers .= 'Content-transfer-encoding: 8bit'."\r\n";

		if($cc != "")
			$headers .= 'Cc: '.$cc."\r\n";
		if($bcc != "")
			$headers .= 'Bcc: '.$bcc."\r\n";
		if($this->freeMail($to, $subject, $eBody, $headers)==false){#pp.free.fr Fix : Warning: mail(): 1 in adhesion.php on line 901
			return FALSE;//$out.="<pre style='border: 1px dotted #666666;padding:10px;'><code>L'envoi du message n'a pas été réalisé en raison des limitations des serveurs de Free, merci de réessayer un peu plus tard.</code></pre>";
		} else {return TRUE;}
/*
		if(mail($to, $subject, $eBody, $headers)){#BASIQUE
			return TRUE;
		} else {
			return FALSE;
		}
*/
	}
#les.pages.perso.chez.free.fr/l-art-d-envoyer-des-mails-depuis-les-pp-de-free.io
	public function freeMail($to, $subject, $message, $additional_headers=null, $additional_parameters=null) {
		$start_time = time();
		$res = mail($to, $subject, $message, $additional_headers, $additional_parameters);
		$time = time() - $start_time;
		if(strpos('free.fr',$_SERVER["HTTP_HOST"])) $res = $res & ($time>1);//si free.fr
		return $res;
	}

	/**
	 * Méthode permettant de mettre en forme le mail de notification à l'administrateur
	 *
	 * @param $nom string nom de l'adhérent
	 * @param $prenom string prenom de l'adhérent
	 * @param $adresse1 string première partie de l'adhérent
	 * @param $adresse2 string deuxième partie de l'adhérent
	 * @param $cp numeric code postal de l'adhérent
	 * @param $ville string ville de l'adhérent
	 * @param $tel numeric téléphone de l'adhérent
	 * @param $mail string email de l'adhérent
	 * @param $choix string choix de l'adhérent quant à l'adhésion
	 * @param $mailing string choix de l'adhérent quant à l'envoi de mail par l'asso
	 * @param $pro array ensemble des caractéristiques professionnelles
	 *
	 * @return string
	 * @author Cyril MAGUIRE
 	 */
	public function notification($nom,$prenom,$adresse1,$adresse2,$cp,$ville,$tel,$mail,$choix,$mailing,$pro=array()) {
		return '
		<table style="border:none;">
			<thead>
				<tr>
					<th style="border:none;text-align:left;">'.$this->getLang('NAME').'&nbsp;: '.$nom.'</th>
				</tr>
				<tr>
					<th style="border:none;text-align:left;">'.$this->getLang('FIRST_NAME').'&nbsp;: '.$prenom.'</th>
				</tr>
			</thead>
			<tbody>
				'.($this->getParam('typeAnnuaire') == 'professionnel' ?
			'
				<tr>
					<td style="border:none;">'.$this->getLang('L_FORM_ACTIVITY').'&nbsp;: '.$pro['activite'].'</td>
				</tr>
				<tr>
					<td style="border:none;">'.$this->getLang('L_FORM_SOCIETY').'&nbsp;: '.$pro['etablissement'].'</td>
				</tr>
				<tr>
					<td style="border:none;">'.$this->getLang('L_FORM_SERVICE').'&nbsp;: '.$pro['service'].'</td>
				</tr>
			': '').'
				<tr>
					<td style="border:none;">'.$this->getLang('L_FORM_ADDRESS').'&nbsp;: '.$adresse1.'</td>
				</tr>
				<tr>
					<td style="border:none;">'.$adresse2.'</td>
				</tr>
				<tr>
					<td style="border:none;">'.$this->getLang('L_FORM_ZIP_CODE').'&nbsp;: '.$cp.'</td>
				</tr>
				<tr>
					<td style="border:none;">'.$this->getLang('L_FORM_CITY').'&nbsp;: '.$ville.'</td>
				</tr>
				<tr>
					<td style="border:none;">'.$this->getLang('L_FORM_TEL').'&nbsp;: '.$this->formatFrenchPhoneNumber($tel).'</td>
				</tr>
				'.($this->getParam('typeAnnuaire') == 'professionnel' ?
			'
				<tr>
					<td style="border:none;">'.$this->getLang('L_FORM_TEL_OFFICE').'&nbsp;: '.$this->formatFrenchPhoneNumber($pro['tel_office']).'</td>
				</tr>
			': '').'
				<tr>
					<td style="border:none;">&nbsp;</td>
				</tr>
				<tr>
					<td style="border:none;">'.$this->getLang('L_NOTI_MAIL').'&nbsp;: '.$mail.'</td>
				</tr>
				<tr>
					<td style="border:none;">'.(($choix == 'adhesion') ? $this->getLang('L_ADHESION_OK').' '.$this->getParam('nom_asso') : ($choix == 'renouveler') ? $this->getLang('L_ADHESION_RENEW') : $this->getLang('L_ADHESION_STOP')).'</td>
				</tr>
				'.($this->getParam('showAnnuaire') == 'on' ?
			'
				<tr>
					<td style="border:none;">'.(($pro['coordonnees'] == 'rec') ? $this->getLang('L_COORD_REC') : ($pro['coordonnees'] == 'public') ? $this->getLang('L_COORD_PUBLIC') : $this->getLang('L_COORD_NO')).'</td>
				</tr>
			': '').'
				<tr>
					<td style="border:none;">'.(($mailing == 'maillist') ? $this->getLang('L_NOTI_RULES_NEWS') : $this->getLang('L_NOTI_RULES_NEWS_NO')).' '.$this->getParam('nom_asso').'</td>
				</tr>
				<tr>
					<td style="border:none;">'.$this->getLang('L_NOTI_SENDING_DATE').' '.date('d/m/Y').'</td>
				</tr>
			</tbody>
		</table>
		';
	}

	/**
	 * Méthode qui affiche un message contenant les instructions à suivre pour régler son adhésion
	 *
	 * @return string
	 * @author Cyril MAGUIRE
	 */
	public function adresse($spam=TRUE) {
		return sprintf($this->getLang('L_ADRESS_HTML'),$this->getParam('nom_asso'),$this->getParam('adresse_asso')).($spam?$this->getLang('L_SPAM_HTML'):'');
	}
	///////////////////////////////////////////////////////////
	//
	// Méthodes permettant la modification des listes de Gutuma
	//
	//////////////////////////////////////////////////////////

	/**
	 * Checks the ending of the specified string
	 * @param string $haystack The string to check
	 * @param string $needle The ending to check for
	 * @return bool TRUE if the string ends with the given string, else FALSE
	 */
	public function strEnds($haystack, $needle) {
		$ending = substr($haystack, strlen($haystack) - strlen($needle));
		return $ending === $needle;
	}

	/**
	 * Loads all of the lists
	 * @param bool $load_addresses TRUE if lists addresses should be loaded (default is FALSE)
	 * @param bool $inc_private TRUE if private lists should included (default is TRUE)
	 * @return mixed Array of lists or FALSE if an error occured
	 */
	public function getAllGutumaLists($load_addresses = FALSE, $inc_private = TRUE){
		$lists = array();
		if (!$this->isGutumaActivated) return $lists;
		if ($dh = opendir(realpath(rtrim($this->GutumaListsDir,'/')))) {
			while (($file = readdir($dh)) !== FALSE) {
				if (!@is_dir($file) && $this->strEnds($file, '.php')) {//Warning: is_dir() [function.is-dir]: open_basedir restriction in effect. File(..) is not within the allowed path(s): (/)
					$list = $this->getGutumaList(substr($file, 0, strlen($file - 4)), $load_addresses);
					if ($inc_private || !$list->private)
						$lists[] = $list;
				}
			}
			closedir($dh);
		}
		return $lists;
	}

	/**
	 * Gets the list with the specified id
	 * @param int $id The list id
	 * @param bool $load_addresses TRUE is list addresses should be loaded (default FALSE)
	 * @return mixed The list or FALSE if an error occured
	 */
	public function getGutumaList($id, $load_addresses = FALSE){
		$time_start = microtime();
		$list = array();
		if (!$this->isGutumaActivated) return $list;
		// Open list file
		$lh = @fopen(realpath(rtrim($this->GutumaListsDir,'/').'/'.$id.'.php'), 'r');
		if ($lh == FALSE)
			return FALSE;
		// Read header from first line
		$header = explode("|", fgetss($lh));

		$list['id'] = $header[0];
		$list['name'] = $header[1];
		$list['private'] = (bool)$header[2];
		$list['size'] = (int)$header[3];

		// Read all address lines
		if ($load_addresses) {
			$addresses = array();
			while (!feof($lh)) {
				$address = trim(fgets($lh));
				if (strlen($address) > 0)
					$addresses[] = $address;
			}
			$list['addresses'] = $addresses;
		}

		fclose($lh);
		return $list;
	}

	/**
	 * Creates a new address list
	 * @param string $name The list name
	 * @param bool $private TRUE if the list should be private (default is FALSE)
	 * @param array $addresses
	 * @return mixed The new list if it was successfully created, else FALSE
	 */
	public function createGutumaList($name, $private = FALSE, $addresses = NULL){
		if (!$this->isGutumaActivated) return true;
		if ($name == '' || preg_match('[^a-zA-Z0-9 \-]', $name))
			return FALSE;
		// Demo mode check for number of addresses
		if (isset($addresses) && count($addresses) >= 100)
			return FALSE;
		// Check for duplicate name
		$all_lists = $this->listsDiff;
		foreach ($all_lists as $l) {
			if (strcasecmp($l->name, $name) == 0)
				return FALSE;
		}
		// Demo mode check for number of lists
		if (count($all_lists) >= 100)
			return FALSE;
		$this->id = time();
		$this->name = $name;
		$this->private = $private;
		$this->addresses = isset($addresses) ? $addresses : array();
		// Save the list
		if (!$this->updateGutumaList()){
			return FALSE;
		}
		return $this;
	}

	/**
	 * Adds the specified address to this list
	 * @param string $address The address to add
	 * @param bool $update TRUE if list should be updated, else FALSE
	 * @return bool TRUE if the address was successfully added
	 */
	public function addAdressInGutumaList($address, $update){

		if (!$this->isGutumaActivated) return true;
		if (in_array($address, $this->addresses))
			return FALSE;

		if (strlen($address) > 320)
			return FALSE;

		if (count($this->addresses) >= 100)
			return FALSE;

		// Add and then sort addresses alphabetically
		$this->addresses[] = $address;
		natcasesort($this->addresses);

		if ($update) {
			if (!$this->updateGutumaList())
				return FALSE;
		}
		return TRUE;
	}

	/**
	 * Updates this address list, i.e., saves any changes
	 * @return bool TRUE if operation was successful, else FALSE
	 */
	public function updateGutumaList() {
		if (!$this->isGutumaActivated) return true;
		$lh = @fopen(realpath(rtrim($this->GutumaListsDir,'/')).'/'.$this->id.'.php', 'w');
		if ($lh == FALSE)
			return FALSE;

		fwrite($lh, "<?php die(); ?>".$this->id.'|'.$this->name.'|'.($this->private ? '1' : '0').'|'.count($this->addresses)."\n");
		foreach ($this->addresses as $a)
			fwrite($lh, $a."\n");

		fclose($lh);
		return TRUE;
	}

	/**
	 * Removes the specified address from this list
	 * @param string $address The address to remove
	 * @param bool $update TRUE if list should be updated, else FALSE	
	 * @return bool TRUE if operation was successful, else FALSE
	 */
	public function removeAdressFromGutumaList($address, $update){
		if (!$this->isGutumaActivated) return true;
		// Create new address array minus the one being removed
		$found = FALSE;
		$newaddresses = array();

		foreach ($this->addresses as $a) {
			if ($address != $a)
				$newaddresses[] = $a;
			else
				$found = TRUE;
		}
		
		if (!$found)
			return FALSE;
	
		$this->addresses = $newaddresses;
		
		if ($update) {
			if (!$this->updateGutumaList())
				return FALSE;
		}
		return TRUE;
	}

	///////////////////////////////////////////////////////////
	//
	// Méthodes permettant la gestion des adhérents
	//
	//////////////////////////////////////////////////////////

	/**
	 * Méthode qui selon le paramètre tri retourne sort ou rsort (tri PHP)
	 *
	 * @param	tri	asc ou desc
	 * @return	string
	 * @author	Stéphane F.
	 **/
	protected function mapTri($tri) {
		if($tri=='desc')
			return 'rsort';
		elseif($tri=='asc')
			return 'sort';
		elseif($tri=='alpha')
			return 'alpha';
		else
			return 'rsort';
	}

	/**
	 * Méthode qui récupere la liste des adherents
	 *
	 * @param	publi	before, after ou all => on récupère tous les fichiers (date) ?
	 * @return	boolean	vrai si articles trouvés, sinon faux
	 * @author	Stéphane F
	 **/
	public function getAdherents($motif) {

		# On fait notre traitement sur notre tri
		$ordre = $this->mapTri('asc');
		# On recupere nos fichiers (tries) selon le motif, la pagination, la date de publication
		if($aFiles = $this->plxGlob_adherents->query($motif,'',$ordre,0,false,'all')) {
			# on mémorise le nombre total d'articles trouvés
			foreach($aFiles as $k=>$v) # On parcourt tous les fichiers
				$array[$k] = $this->parseAdherent(PLX_ROOT.$this->getParam('adherents').'adhesions/'.$v);
			# On stocke les enregistrements dans un objet plxRecord
			$this->plxRecord_adherents = new plxRecord($array);
			return true;
		}
		else return false;
	}


	/**
	 * Méthode qui récupère les infos enregistrées dans le fichier xml d'un adhérent
	 *
	 * @param $filename ressource le chemin vers le fichier de l'adhérent
	 * @return array
	 *
	 * @author Cyril MAGUIRE
	 */
	public function parseAdherent($filename) {

		if(!is_file($filename)) return;

		# Mise en place du parseur XML
		$data = implode('',file($filename));
		$parser = xml_parser_create(PLX_CHARSET);
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$values,$iTags);
		xml_parser_free($parser);
		if(isset($iTags['adherent']) AND isset($iTags['nom'])) {
			$nb = sizeof($iTags['nom']);
			$size=ceil(sizeof($iTags['adherent'])/$nb);
			for($i=0;$i<$nb;$i++) {
				$attributes = $values[$iTags['adherent'][$i*$size]]['attributes'];
				$adherent['id'] = $attributes['number'];
				# Recuperation du nom
				$adherent['nom']=plxUtils::getValue($values[$iTags['nom'][$i]]['value']);
				# Recuperation du prenom
				$adherent['prenom']=plxUtils::getValue($values[$iTags['prenom'][$i]]['value']);
				# Recuperation de l'adresse 1
				$adherent['adresse1']=plxUtils::getValue($values[$iTags['adresse1'][$i]]['value']);
				# Recuperation de l'adresse 2
				$adherent['adresse2']=plxUtils::getValue($values[$iTags['adresse2'][$i]]['value']);
				# Recuperation du code postal
				$adherent['cp']=plxUtils::getValue($values[$iTags['cp'][$i]]['value']);
				# Recuperation de la ville
				$adherent['ville']=plxUtils::getValue($values[$iTags['ville'][$i]]['value']);
				# Recuperation du téléphone
				$adherent['tel']=plxUtils::getValue($values[$iTags['tel'][$i]]['value']);
				# Recuperation du mail
				$adherent['mail']=plxUtils::getValue($values[$iTags['mail'][$i]]['value']);
				# Recuperation du choix quant à l'adhésion
				$adherent['choix']=plxUtils::getValue($values[$iTags['choix'][$i]]['value']);
				# Recuperation du choix pour le mailing
				$adherent['mailing']=plxUtils::getValue($values[$iTags['mailing'][$i]]['value']);
				# Recuperation du statut de l'adhérent
				$adherent['validation']=plxUtils::getValue($values[$iTags['validation'][$i]]['value']);
				# Recuperation de la date de première adhésion
				$adherent['firstDate']=plxUtils::getValue($values[$iTags['firstDate'][$i]]['value']);
				# Recuperation de la date de validation de l'adhésion
				$adherent['date']=plxUtils::getValue($values[$iTags['date'][$i]]['value']);
				# Recuperation de la chaine salt de l'adhérent
				$adherent['salt']=plxUtils::getValue($values[$iTags['salt'][$i]]['value']);
				# Recuperation du mot de passe cripté de l'adhérent
				$adherent['password']=plxUtils::getValue($values[$iTags['password'][$i]]['value']);
				# Recuperation de la clé
				$adherent['cle']=plxUtils::getValue($values[$iTags['cle'][$i]]['value']);
				# Recuperation des chaines aléatoires
				$adherent['rand1']=plxUtils::getValue($values[$iTags['rand1'][$i]]['value']);
				$adherent['rand2']=plxUtils::getValue($values[$iTags['rand2'][$i]]['value']);
				if ($this->getParam('typeAnnuaire') == 'professionnel') {
					# Recuperation de l'activité
					$adherent['activite']=isset($iTags['activite'][$i])?plxUtils::getValue($values[$iTags['activite'][$i]]['value']):'';
					# Recuperation de l'établissement
					$adherent['etablissement']=isset($iTags['etablissement'][$i])?plxUtils::getValue($values[$iTags['etablissement'][$i]]['value']):'';
					# Recuperation du service
					$adherent['service']=isset($iTags['service'][$i])?plxUtils::getValue($values[$iTags['service'][$i]]['value']):'';
					# Recuperation du poste
					$adherent['tel_office']=isset($iTags['tel_office'][$i])?plxUtils::getValue($values[$iTags['tel_office'][$i]]['value']):'';
				}
				if ($this->getParam('showAnnuaire') == 'on') {
					# Recuperation du choix sur le partage des coordonnées
					$adherent['coordonnees']=isset($iTags['coordonnees'][$i])?plxUtils::getValue($values[$iTags['coordonnees'][$i]]['value']):'refus';
				}
			}
		}
		return $adherent;
	}

	/**
	 * Méthode permettant de formater un numéro de téléphone au format français ou international
	 */
	public function formatFrenchPhoneNumber($phoneNumber, $international = FALSE){
		//Supprimer tous les caractères qui ne sont pas des chiffres
		$phoneNumber = preg_replace('/[^0-9]+/', '', $phoneNumber);
		//Garder les 9 derniers chiffres
		$phoneNumber = substr($phoneNumber, -9);
		//On ajoute +33 si la variable $international vaut TRUE et 0 dans tous les autres cas
		$motif = $international ? '+33 (\1) \2 \3 \4 \5' : '0\1 \2 \3 \4 \5';
		$phoneNumber = preg_replace('/(\d{1})(\d{2})(\d{2})(\d{2})(\d{2})/', $motif, $phoneNumber);

		return $phoneNumber;
	}

	/**
	 * Méthode qui retourne le prochain id d'un adhérent
	 *
	 * @return	string		id d'un nouvel adhérent sous la forme 0001
	 * @author	Stephane F.
	 **/
	public function nextIdAdherent() {
		# On récupère l'ensemble des adhérents
		//$this->adherentsList = $this->getAdherent(PLX_ROOT.$this->getParam('adherents').'plugin.adhesion.adherents.xml');
		# On récupère le dernier identifiant
		if($aKeys = array_keys($this->plxGlob_adherents->aFiles)) {
			rsort($aKeys);
			return str_pad($aKeys['0']+1,5, '0', STR_PAD_LEFT);
		} else {
			return '00001';
		}
	}

	/**
	 * Méthode permettant de supprimer les adhérents sélectionnés
	 *
	 * @param $content 	array tableau contenant les index des adhérents à supprimer
	 * @param $mail 	array tableau optionnel contenant les paramètres des mails à envoyer pour confirmation
	 *
	 * @return bool
	 * @author Cyril MAGUIRE
	 */
	public function deleteAdherentsList(&$content,$mail=array(null)) {
		$action = FALSE;
		foreach($content['idAdherent'] as $k=>$id) {
			# Vérification de l'intégrité de l'identifiant
			if(!preg_match('/^[0-9]{5}$/',$id))
				return false;
			# Variable d'état
			$resDelAd = true;
			# Suppression de l'adhérent
			if($globAd = $this->plxGlob_adherents->query('~^'.$id.'\.(.*).xml$~')) {
				unlink(PLX_ROOT.$this->getParam('adherents').'adhesions/'.$globAd['0']);
				$resDelAd = !file_exists(PLX_ROOT.$this->getParam('adherents').'adhesions/'.$globAd['0']);
				foreach ($content as $d => $di){
					if(strstr($d,'_'.$id)) unset($content[$d]);# remove from content 4 non propagation in caller function
				}
			}
			$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_REMOVE_ADH'),$content['nom_'.$id]).'<br/>' ;
			$action = TRUE;
		}
		//On retire l'email de la liste de diffusion
		if (in_array($content['mail_'.$id],$this->listDiff)) {
			$this->removeAdressFromGutumaList($content['mail_'.$id],TRUE);
			$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_REMOVE_ADD'),$content['mail_'.$id],$content['nom_'.$id]).'<br/>' ;
		}
		unset($content['idAdherent']);
		return $action;
	}

	/**
	 * Méthode permettant d'ajouter les mentions légales de la cnil aux mails envoyés avec le lien de suppression
	 *
	 * @param $id 		string index de l'adhérent
	 * @param $mail 	string mail de l'adhérent
	 * @param $text 	string mail au format texte ou html (html par défaut)
	 *
	 * @return string
	 * @author Cyril MAGUIRE
	 *
	 */
	public function cnil($id=0,$mail='',$text=FALSE) {
		$this->plxMotor = plxMotor::getInstance();
		if ($id == 0 && $mail == '') {
			if ($text) {
				return $this->getLang('L_CNIL_NO_REPLY_TEXT');
			} else {
				return '<p style="text-align:center;">'.str_replace(PHP_EOL.PHP_EOL,'<br/><hr/>',$this->getLang('L_CNIL_NO_REPLY_TEXT')).'</p>';
			}
		} else {
			$cnillink = $this->plxMotor->urlRewrite('?adhesion&q='.md5($id.'-'.$mail));
			if ($text) {
				return $this->getLang('L_CNIL_NO_REPLY_TEXT').PHP_EOL.$this->getLang('L_CNIL_TEXT').'&nbsp;: '.$cnillink;
			} else {
				return '<p style="text-align:center;">'.str_replace(PHP_EOL.PHP_EOL ,'<br/><hr/>',$this->getLang('L_CNIL_NO_REPLY_TEXT')).'<br/><a href="'.$cnillink.'">'.$this->getLang('L_CNIL_LINK').'</a></p>';
			}
		}
	}

	/**
	 * Méthode permettant de comparer les données du lien cnil et le cas échéant de supprimer le compte associé des listes de diffusion
	 * todo : add salt & sha1?
	 * @param $value string 	$value = md5($id-$mail);
	 *
	 * @return bool
	 * @author Cyril MAGUIRE
	 */
	public function compare($value) {
		$content['idAdherent'] = array();
		$mail = array();
		foreach ($this->plxRecord_adherents->result as $id => $array) {
			if ($value == md5($array['id'].'-'.$array['mail']) && $array['validation'] == '1') {
				$content['idAdherent'][] = $array['id'];
				foreach ($array as $key => $value) {
					$content[$key.'_'.$array['id']] = $value;
				}
				$content['mailing_'.$array['id']] = 'blacklist';
				$content['selection'][0] ='update';
				$addresses = $this->getAllGutumaLists(TRUE);
				$this->listDiff = $addresses[0]['addresses'];
				$this->editAdherentsList($content,$array['id'],TRUE);
				return TRUE;
			}
		}
		return FALSE;
	}

	/**
	 * Générateur de chaines de caractères aléatoire
	 *
	 * @param $nbLettres integer Nombre de caractères que la chaine contiendra
	 * @param $nbCaracteres integer Nombre de caracteres exotiques maximum que la chaine contiendra
	 * @param $caracteresSup array Caracteres exotiques que la chaine ne contiendra pas
	 * @param $voyellesSup array Voyelles que la chaine ne contiendra pas
	 * @param $consonnesSupp array Consonnes que la chaine ne contiendra pas
	 *
	 * @return string la chaine aléatoire
	 * @author Cyril MAGUIRE
	 */
	public function generateurMot($nbLettres = 8,$nbCaracteres = 4,$caracteresSup = array(),$nombresSup = array(),$voyellesSup = array(),$consonnesSupp = array()) {

		$mot = '';
		$choix = array('consonnes','voyelles','caracteres','nombres');
		$nombres = array('0','1','2','3','4','5','6','7','8','9');
		$voyelles = array('a','e','i','o','u','y');
		$consonnes = array('b','c','d','f','g','h','j','k','l','m','n','p','q','r','s','t','v','w','x','z');
		$caracteres = array('@','#','?','!','+','=','-','%','&','*');

		if (!empty($consonnesSupp)) {
			$consonnes = array_diff($consonnes,$consonnesSupp);
		}
		if (!empty($voyellesSup)) {
			$voyelles = array_diff($voyelles,$voyellesSup);
		}
		if (!empty($caracteresSup)) {
			$caracteres = array_diff($caracteres,$caracteresSup);
		}
		if (!empty($nombresSup)) {
			$nombres = array_diff($nombres,$nombresSup);
		}
		if (empty($consonnes)) {
			$consonnes = array('b');
		}
		if (empty($voyelles)) {
			$voyelles = $consonnes;
		}
		if (empty($nombres)) {
			$nombres = $consonnes;
		}
		if ($nbCaracteres == 0) {
			$caracteres = $consonnes;
		}

		$j = 0;
		for($i=0;$i<$nbLettres;$i++) {
			//choix aléatoire entre consonnes et voyelles
			$rand = array_rand($choix,1);
			if ($rand == 3) {
				$j++;
			}
			if ($nbCaracteres != 0 && $j == ($nbCaracteres-1)) {
				$caracteres = $consonnes;
			}
			$type = $choix[$rand];
			$tab = $$type;
			//on recherche l'index d'une lettre, au hasard dans le tableau choisi
			$lettre = array_rand($$type,1);
			//on recherche la dernière lettre du mot généré
			if (strlen($mot) > 0) {
				$derniereLettre = $mot[strlen($mot)-1];
			} else {
				$derniereLettre = '';
			}

			//si la lettre choisie est déjà à la fin du mot généré, on relance la boucle
			if ($tab[$lettre] == $derniereLettre || in_array($derniereLettre,$tab)) {
				$i--;
			} else {//sinon on l'ajoute au mot généré
				$maj = mt_rand(0,10);
				if ($maj<2) {
					$mot .= strtoupper($tab[$lettre]);	
				} else {
					$mot .= $tab[$lettre];	
				}
			}
		}
		return $mot;
	}

	/**
	 * Méthode permettant de définir un mot de passe et une clé lors d'une nouvelle inscription validée
	 *
	 * @param $id 	string index de l'adhérent : type : 00001
	 *
	 * @return $password string mot de passe de l'adhérent en clair
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function defPassword($id) {
		if (array_key_exists($id, $this->adherentsList)){
			$id = $this->adherentsList[$id];
		}else{
			$id = end($this->adherentsList) + 1;
		}
		if (empty($this->plxRecord_adherents->result[$id]['firstDate'])) {
			$this->plxRecord_adherents->result[$id]['firstDate'] = time();
		}
//crée
		$sel = plxUtils::charAleatoire(10);
		$cle = plxUtils::charAleatoire($this->getParam('cle'));
		$max = strlen($this->plxRecord_adherents->result[$id]['mail']);
		$min = $max > 10 ? 9 : 1;
		$rand1 = mt_rand($min,$max);
		$rand2 = $this->generateurMot(3,1);
		$password = $cle.'-'.substr($this->plxRecord_adherents->result[$id]['mail'],0,-$rand1).$rand2;//ici
//garde
		$this->plxRecord_adherents->result[$id]['salt'] = $sel;
		$this->plxRecord_adherents->result[$id]['password'] = sha1($sel.md5($password));//hash
		$this->plxRecord_adherents->result[$id]['rand1'] = $rand1;
		$this->plxRecord_adherents->result[$id]['rand2'] = $rand2;
		$this->plxRecord_adherents->result[$id]['cle'] = $cle;
//donne le passe
		return $password;
	}

	/**
	 * Méthode qui retourne les informations $output en analysant
	 * le nom du fichier de l'adhérent $filename
	 *
	 * @param	filename	fichier de l'adhérent à traiter
	 * @return	array		information à récupérer
	 * @author	Stephane F
	 **/
	public function adInfoFromFilename($filename) {

		# On effectue notre capture d'informations
		if(preg_match('/([0-9]{5}).([a-z-]+).([a-z-]+).([0-9]{10}).xml$/',$filename,$capture)) {
			return array(
				'adId'		=> $capture[1],
				'nom'		=> $capture[2],
				'prenom'	=> $capture[3],
				'firstDate'	=> $capture[4]
			);
		}
	}

	/**
	 * Méthode permettant de mettre à jour un compte adhérent
	 *
	 * @param $content array tableau contenant les informations des comptes à mettre à jour
	 *
	 * @return $mail array tableau contenant les paramètres des mails à envoyer aux adhérents
	 * @author Cyril MAGUIRE
	 */
	public function updateAdherentsList($content) {
		$mail = array();

		foreach($content['idAdherent'] as $key => $id) {
			$ad = $this->adherentsList[$id];
			//L'adhérent souhaite ne plus faire partie de l'association
			if ($content['choix_'.$id] == 'stop') {
				$this->plxRecord_adherents->result[$ad]['choix'] = $content['choix_'.$id];
				$mail[] = array(
					'name'=>$this->getParam('nom_asso'),
					'from'=>$this->getParam('email'),
					'to'=>$content['mail_'.$id],
					'subject'=>$this->getParam('devalidation_subject'),
					'body'=>'<p>'.$this->getParam('devalidation_msg').'</p>'.$this->cnil(),
					'contentType'=>'html',
					'cc'=>FALSE,
					'bcc'=>FALSE,
					'notification' => array(
						'adherent' => $this->plxRecord_adherents->result[$ad],
						'sujet' => $this->getLang('L_SUPPRESSION')
					)
				);
				$this->deleteAdherentsList($content,$mail);
				return FALSE;
			}
			elseif($content['nom_'.$id]!='') {
				$this->plxRecord_adherents->result[$ad]['nom'] = $content['nom_'.$id];
				$this->plxRecord_adherents->result[$ad]['prenom'] = $content['prenom_'.$id];
				$this->plxRecord_adherents->result[$ad]['adresse1'] = $content['adresse1_'.$id];
				$this->plxRecord_adherents->result[$ad]['adresse2'] = $content['adresse2_'.$id];
				$this->plxRecord_adherents->result[$ad]['cp'] = $content['cp_'.$id];
				$this->plxRecord_adherents->result[$ad]['ville'] = $content['ville_'.$id];
				$this->plxRecord_adherents->result[$ad]['tel'] = $this->formatFrenchPhoneNumber($content['tel_'.$id]);
				if($this->plxRecord_adherents->result[$ad]['mail'] != $content['mail_'.$id]){//remove old mail in gutuma list
					$this->removeAdressFromGutumaList($this->plxRecord_adherents->result[$ad]['mail'],TRUE);
					$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_REMOVE_ADD'),$this->plxRecord_adherents->result[$ad]['mail'],$content['nom_'.$id]).'<br/>';
					$this->plxRecord_adherents->result[$ad]['mail'] = $content['mail_'.$id];
					$password = $this->defPassword($id);//Définition du mot de passe
					$this->plxRecord_adherents->result[$ad]['password'] = sha1($this->plxRecord_adherents->result[$ad]['salt'].md5($password));
					$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_NEW_PASS'),$this->plxRecord_adherents->result[$ad]['mail'],$content['nom_'.$id]).'<br/>';
				}
				else $this->plxRecord_adherents->result[$ad]['mail'] = $content['mail_'.$id];
				$this->plxRecord_adherents->result[$ad]['mailing'] = $content['mailing_'.$id];
				$this->plxRecord_adherents->result[$ad]['choix'] = $content['choix_'.$id];
				if ($this->getParam('typeAnnuaire') == 'professionnel') {
					if ($content['activite_'.$id] == 'autre') {
						$this->plxRecord_adherents->result[$ad]['activite'] = $content['activite_autre_'.$id]?$content['activite_autre_'.$id]:$this->getLang('L_ADMIN_NOT_DONE');
					} else {
						$this->plxRecord_adherents->result[$ad]['activite'] = $content['activite_'.$id];
					}
					$this->plxRecord_adherents->result[$ad]['etablissement'] = $content['etablissement_'.$id];
					$this->plxRecord_adherents->result[$ad]['service'] = $content['service_'.$id];
					$this->plxRecord_adherents->result[$ad]['tel_office'] = $this->formatFrenchPhoneNumber($content['tel_office_'.$id]);
				}
				if ($this->getParam('showAnnuaire') == 'on') {
					$this->plxRecord_adherents->result[$ad]['coordonnees'] = $content['coordonnees_'.$id];
				}
				//On retire l'email de la liste de diffusion si c'est le choix de l'adhérent et s'il est non validé
				if (in_array($content['mail_'.$id],$this->listDiff) AND ($content['mailing_'.$id] == 'blacklist' OR ($content['validation_'.$id] == '0' AND $content['choix_'.$id] != 'renouveler' AND $content['selection'][0] == 'update'))) {
					$this->removeAdressFromGutumaList($content['mail_'.$id],TRUE);
					$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_REMOVE_ADD'),$content['mail_'.$id],$content['nom_'.$id]).'<br/>';//On notifie
				} elseif (!in_array($content['mail_'.$id],$this->listDiff) && $content['mailing_'.$id] != 'blacklist' && ($content['selection'][0]=='update')) {
					$this->addAdressInGutumaList($content['mail_'.$id],TRUE);
					$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_ADD_ADD'),$content['mail_'.$id],$content['nom_'.$id]).'<br/>';//On notifie
				}

				$this->plxRecord_adherents->result[$ad]['mailing'] = $content['mailing_'.$id];
				if ($content['selection'][0]!='update') {
					if ($this->plxRecord_adherents->result[$ad]['validation'] == '1' && $content['choix_'.$id] == 'renouveler') {
						$_SESSION['erase']['m'] = '<p id="password_error">'.$this->getLang('L_ERR_USER_ALREADY_VALID').'</p>';//On notifie (PUBLIC)
						$_SESSION['erase']['d'] = 'e';//display what
						$_SESSION['info'] .= $this->getLang('L_ERR_USER_ALREADY_VALID').' : '.$content['nom_'.$id].' '.$content['mail_'.$id].'<br/>';//On notifie
						header('Location:'.$this->plxMotor->racine.$this->plxMotor->path_url/*.$this->plxMotor->get*/);#$this->plxMotor->urlRewrite()#old
						exit;
					}
					$this->plxRecord_adherents->result[$ad]['validation'] = $content['validation_'.$id];
//Si l'inscription n'est pas validée
//On supprime l'inscription de l'adhérent mais on conserve ses coordonnées
					if ($this->plxRecord_adherents->result[$ad]['validation'] == '0' && $content['choix_'.$id] != 'renouveler') {
						if (in_array($content['mail_'.$id],$this->listDiff)) {//On retire l'email de la liste de diffusion
							$this->removeAdressFromGutumaList($content['mail_'.$id],TRUE);
							$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_REMOVE_ADD'),$content['mail_'.$id],$content['nom_'.$id]).'<br/>';
						}
//On efface
						$this->plxRecord_adherents->result[$ad]['salt'] = '';//le contrôle de mot de passe
						$this->plxRecord_adherents->result[$ad]['password'] = '';//le mot de passe
						$this->plxRecord_adherents->result[$ad]['cle'] = '';//la clé
						$this->plxRecord_adherents->result[$ad]['rand1'] = '';//chaine aléatoire1
						$this->plxRecord_adherents->result[$ad]['rand2'] = '';//chaine aléatoire2
						$this->plxRecord_adherents->result[$ad]['date'] = time();//la date de la validation

						$mail[] = array(
							'name'=>$this->getParam('nom_asso'),
							'from'=>$this->getParam('email'),
							'to'=>$content['mail_'.$id],
							'subject'=>$this->getParam('devalidation_subject'),
							'body'=>'<p>'.$this->getParam('devalidation_msg').'</p>'.$this->cnil(),
							'contentType'=>'html',
							'cc'=>FALSE,
							'bcc'=>FALSE,
							'notification' => array(
								'adherent' => $this->plxRecord_adherents->result[$ad],
								'sujet' => $this->getLang('L_MODIFICATION')
							)
						);
						$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_DEVALIDATION_ADH'),$content['nom_'.$id]).'<br/>';//On notifie
					}
					if ($this->plxRecord_adherents->result[$ad]['validation'] == '1' && $content['choix_'.$id] == 'renouveler') {//Si c'est une demande de renouvellement
						$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_VALIDATION_ADH'),$content['nom_'.$id]).'<br/>';//On notifie
//On efface
						$this->plxRecord_adherents->result[$ad]['salt'] = '';//le contrôle de mot de passe
						$this->plxRecord_adherents->result[$ad]['password'] = '';//le mot de passe
						$this->plxRecord_adherents->result[$ad]['cle'] = '';//la clé
						$this->plxRecord_adherents->result[$ad]['rand1'] = '';//chaine aléatoire1
						$this->plxRecord_adherents->result[$ad]['rand2'] = '';//chaine aléatoire2
						$this->plxRecord_adherents->result[$ad]['date'] = time();//la date de la validation

						$mail[] = array(
							'name'=>$this->getParam('nom_asso'),
							'from'=>$this->getParam('email'),
							'to'=>$content['mail_'.$id],
							'subject'=>$this->getParam('subject'),
							'body'=>'<p>'.$this->getParam('thankyou').'</p>'.$this->adresse().$this->cnil(),
							'contentType'=>'html',
							'cc'=>FALSE,
							'bcc'=>FALSE,
							'notification' => array(
								'adherent' => $this->plxRecord_adherents->result[$ad],
								'sujet' => $this->getLang('L_MODIFICATION')
							)
						);
						$_SESSION['info'] .= $this->getLang('L_FORM_NEW').'<br/>';//On notifie
					}
					if ($content['validation_'.$id] == '1') {//On valide l'inscription de l'adhérent
						if ($content['mailing_'.$id] == 'maillist') {//On ajoute l'email à l'ensemble des mails de la liste de diffusion
							$this->addAdressInGutumaList($content['mail_'.$id],TRUE);
							$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_ADD_ADD'),$content['mail_'.$id],$content['nom_'.$id]).'<br/>';//On notifie
						}
						if (!empty($this->plxRecord_adherents->result[$id]['cle'])
						 && !empty($this->plxRecord_adherents->result[$id]['mail'])
						 && !empty($this->plxRecord_adherents->result[$id]['rand1'])
						 && !empty($this->plxRecord_adherents->result[$id]['rand2'])
						) {//Affichage du mot de passe
							$password = $this->plxRecord_adherents->result[$id]['cle'].'-'.substr($this->plxRecord_adherents->result[$id]['mail'],0,-$this->plxRecord_adherents->result[$id]['rand1']).$this->plxRecord_adherents->result[$id]['rand2'];
						} else {
							$password = $this->defPassword($id);
							$this->plxRecord_adherents->result[$ad]['password'] = sha1($this->plxRecord_adherents->result[$ad]['salt'].md5($password));//Hash Pass
						}
						$this->plxRecord_adherents->result[$ad]['validation'] = strval($content['validation_'.$id]);
						$this->plxRecord_adherents->result[$ad]['date'] = time();//On ajoute la date de la validation
						if (empty($this->plxRecord_adherents->result[$ad]['firstDate'])) {
							$this->plxRecord_adherents->result[$ad]['firstDate'] = $this->plxRecord_adherents->result[$ad]['date'];
						}

						$mail[] = array(
							'name'=>$this->getParam('nom_asso'),
							'from'=>$this->getParam('email'),
							'to'=>$content['mail_'.$id],
							'subject'=>$this->getParam('validation_subject'),
							'body'=>'<p>'.$this->getParam('validation_msg').'</p><p>&nbsp;</p><p>'.$this->getLang('L_ADMIN_ID').'</p><p>&nbsp;</p><p>'.$this->getLang('L_ADMIN_PASSWORD').'</p><p><strong>'.$password.'</strong></p>'.$this->cnil($id,$content['mail_'.$id]),
							'contentType'=>'html',
							'cc'=>FALSE,
							'bcc'=>FALSE,
							'notification' => array(
								'adherent' => $this->plxRecord_adherents->result[$ad],
								'sujet' => $this->getLang('L_VALIDATION')
							)
						);
						$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_VALIDATION_ADH'),$content['nom_'.$id]).'<br/>';//On notifie
					}
				}
				else {
					if ($this->plxRecord_adherents->result[$ad]['password'] != '') {
						$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_UPDATE_ADH'),$content['nom_'.$id]).'<br/>';//On notifie
						$this->plxRecord_adherents->result[$ad]['validation'] = $content['validation_'.$id];

						$mail = array(null);//On n'envoie pas de mail de confirmation
					} else {
						$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_UPDATE_ADH'),$content['nom_'.$id]).'<br/>';//On notifie
						$password = $this->plxRecord_adherents->result[$ad]['cle'].'-'.substr($this->plxRecord_adherents->result[$ad]['mail'],0,-$this->plxRecord_adherents->result[$ad]['rand1']).$this->plxRecord_adherents->result[$ad]['rand2'];
						$this->plxRecord_adherents->result[$ad]['validation'] = $content['validation_'.$id];

						$mail[] = array(
							'name'=>$this->getParam('nom_asso'),
							'from'=>$this->getParam('email'),
							'to'=>$content['mail_'.$id],
							'subject'=>$this->getParam('validation_subject'),
							'body'=>'<p>'.$this->getParam('validation_msg').'</p><p>'.$this->getLang('L_YOUR PASS_IS').' :</p><p><strong>'.$password.'</strong></p>'.$this->cnil($id,$content['mail_'.$id]),
							'contentType'=>'html',
							'cc'=>FALSE,
							'bcc'=>FALSE,
							'notification' => array(
								'adherent' => $this->plxRecord_adherents->result[$ad],
								'sujet' => $this->getLang('L_MODIFICATION')
							)
						);
					}
				}
			}
		}
		return $mail;
	}
	
	/**
	 * Méthode qui insère un nouvel adhérent dans la liste des adhérents
	 *
	 * @param	content	tableau multidimensionnel du plugin adhesion
	 *
	 * @return	bool
	 * @author	MAGUIRE Cyril
	 **/
	public function insertNewAdherent($content) {
		$mail = array();
		$id = $content['new'];
//~		 $this->getAdherents('/^[0-9]{5}.(.[a-z-]+){2}.[0-9]{10}.xml$/');
		$isAlreadyExists = $this->isAlreadyExists($content,$id);
		if ($isAlreadyExists) {
			if ($content['choix_'.$id] != 'adhesion') {
				foreach ($this->plxRecord_adherents->result as $key => $value) {
					if($value['mail'] == $content['mail_'.$id]) {
						$adherent = array(
							'nom_'.$key => $value['nom'],
							'prenom_'.$key => $value['prenom'],
							'adresse1_'.$key => $value['adresse1'],
							'adresse2_'.$key => $value['adresse2'],
							'cp_'.$key => $value['cp'],
							'ville_'.$key => $value['ville'],
							'tel_'.$key => $value['tel'],
							'mail_'.$key => $value['mail'],
							'choix_'.$key => $content['choix_'.$id],
							'mailing_'.$key => $content['mailing_'.$id],
							'validation_'.$key => $value['validation']
						);
						if ($this->getParam('typeAnnuaire') == 'professionnel') {
							if ($value['activite'] == 'autre') {
								$adherent['activite'] = $value['activite_autre'];
							} else {
								$adherent['activite'] = $value['activite'];
							}
							$adherent['etablissement'] = $value['etablissement'];
							$adherent['service'] = $value['service'];
							$adherent['tel_office'] = $value['tel_office'];
						}
						if ($this->getParam('showAnnuaire') == 'on') {
							$adherent['coordonnees'] = $content['coordonnees'];
						}
						$adherent['idAdherent'][] = $key;
					}
				}
				$mail = $this->updateAdherentslist($adherent);

				unset($content);
			} else {
				if ($this->plxMotor->mode == 'static') {
					$_SESSION['erase']['m'] = '<p id="password_error">'.$this->getLang('L_ERR_USER_ALREADY_USED').'</p>';
					$_SESSION['erase']['d'] = 'e';//display what
					header('Location:'.$this->plxMotor->urlRewrite());
					exit();
				} else {
					$_SESSION['error'] = $this->getLang('L_ERR_USER_ALREADY_USED');
					header('Location:'.$this->plxMotor->urlRewrite('core/admin/plugin.php').'?p='.__CLASS__);
					exit();
				}

			}
		}
		if(isset($content['nom_'.$id]) && $content['nom_'.$id] !='') {

			$ad = end($this->adherentsList)+1;

			$this->plxRecord_adherents->result[$ad]['nom'] = $content['nom_'.$id];
			$this->plxRecord_adherents->result[$ad]['prenom'] = $content['prenom_'.$id];
			$this->plxRecord_adherents->result[$ad]['adresse1'] = $content['adresse1_'.$id];
			$this->plxRecord_adherents->result[$ad]['adresse2'] = $content['adresse2_'.$id];
			$this->plxRecord_adherents->result[$ad]['cp'] = $content['cp_'.$id];
			$this->plxRecord_adherents->result[$ad]['ville'] = $content['ville_'.$id];
			$this->plxRecord_adherents->result[$ad]['tel'] = $this->formatFrenchPhoneNumber($content['tel_'.$id]);
			$this->plxRecord_adherents->result[$ad]['mail'] = $content['mail_'.$id];
			$this->plxRecord_adherents->result[$ad]['choix'] = $content['choix_'.$id];
			$this->plxRecord_adherents->result[$ad]['mailing'] = $content['mailing_'.$id];
			if ($this->getParam('typeAnnuaire') == 'professionnel') {
				if ($content['activite_'.$id] == 'autre') {
					$this->plxRecord_adherents->result[$ad]['activite'] = $content['activite_autre_'.$id];
				} else {
					$this->plxRecord_adherents->result[$ad]['activite'] = $content['activite_'.$id];
				}
				$this->plxRecord_adherents->result[$ad]['etablissement'] = $content['etablissement_'.$id];
				$this->plxRecord_adherents->result[$ad]['service'] = $content['service_'.$id];
				$this->plxRecord_adherents->result[$ad]['tel_office'] = $content['tel_office_'.$id];
				if ($this->getParam('showAnnuaire') == 'on') {
					$this->plxRecord_adherents->result[$ad]['coordonnees'] = $content['coordonnees_'.$id];//fix:Fatal error: Unsupported operand types in adhesion/adhesion.php on line 1519 BUT provoc : Notice: Undefined index: coordonnees in adhesion/adhesion.php on line 1944
				}
			}
			//Définition du mot de passe
			$password = $this->defPassword($id);
			$this->plxRecord_adherents->result[$ad]['password'] = sha1($this->plxRecord_adherents->result[$ad]['salt'].md5($password));
			$this->plxRecord_adherents->result[$ad]['validation'] = '0';
			$this->plxRecord_adherents->result[$ad]['firstDate'] = '';
			$this->plxRecord_adherents->result[$ad]['date'] = '';
			$_SESSION['info'] .= sprintf($this->getLang('L_ADMIN_NEW_ADH'),$content['nom_'.$id]).'<br />';
			$mail[] = array(
				'name'=>$this->getParam('nom_asso'),
				'from'=>$this->getParam('email'),
				'to'=>$content['mail_'.$id],
				'subject'=>$this->getParam('subject'),
				'body'=>'<p>'.$this->getParam('thankyou').'</p>'.$this->adresse().$this->cnil($id,$content['mail_'.$id]),
				'contentType'=>'html',
				'cc'=>FALSE,
				'bcc'=>FALSE
			);
		}
		return $mail;
	}

	/**
	 * Méthode qui écrit le fichier XML selon la liste des adhérents
	 *
	 * @param	$mail array tableau contenant les paramètres du mail à envoyer lors de la mise à jour du fichier
	 *
	 * @return	bool
	 * @author	MAGUIRE Cyril
	 **/
	public function recAdherentsList($mail,$id=false) {
			if ($id === false) {
				$id = $this->nextIdAdherent();
				$ad = end($this->adherentsList)+1;
			} else {
				$ad = $this->adherentsList[$id];
			}
			$adherent = $this->plxRecord_adherents->result[$ad];
			# On génére le fichier XML
			$xml = "<?xml version=\"1.0\" encoding=\"".PLX_CHARSET."\"?>\n";
			$xml .= "<document>\n";
				$xml .= "\t<adherent number=\"".$id."\">\n\t\t";
				$xml .= "<nom><![CDATA[".plxUtils::cdataCheck($adherent['nom'])."]]></nom>\n\t\t";
				$xml .= "<prenom><![CDATA[".plxUtils::cdataCheck($adherent['prenom'])."]]></prenom>\n\t\t";
				$xml .= "<adresse1><![CDATA[".plxUtils::cdataCheck($adherent['adresse1'])."]]></adresse1>\n\t\t";
				$xml .= "<adresse2><![CDATA[".plxUtils::cdataCheck($adherent['adresse2'])."]]></adresse2>\n\t\t";
				$xml .= "<cp><![CDATA[".plxUtils::cdataCheck($adherent['cp'])."]]></cp>\n\t\t";
				$xml .= "<ville><![CDATA[".plxUtils::cdataCheck($adherent['ville'])."]]></ville>\n\t\t";
				$xml .= "<tel><![CDATA[".plxUtils::cdataCheck($adherent['tel'])."]]></tel>\n\t\t";
				$xml .= "<mail><![CDATA[".plxUtils::cdataCheck($adherent['mail'])."]]></mail>\n\t\t";

				$xml .= "<choix><![CDATA[".plxUtils::cdataCheck($adherent['choix'])."]]></choix>\n\t\t";
				$xml .= "<mailing><![CDATA[".plxUtils::cdataCheck($adherent['mailing'])."]]></mailing>\n\t\t";
				$xml .= "<salt><![CDATA[".plxUtils::cdataCheck($adherent['salt'])."]]></salt>\n\t\t";
				$xml .= "<password><![CDATA[".plxUtils::cdataCheck($adherent['password'])."]]></password>\n\t\t";
				$xml .= "<rand1><![CDATA[".plxUtils::cdataCheck($adherent['rand1'])."]]></rand1>\n\t\t";
				$xml .= "<rand2><![CDATA[".plxUtils::cdataCheck($adherent['rand2'])."]]></rand2>\n\t\t";
				$xml .= "<cle><![CDATA[".plxUtils::cdataCheck($adherent['cle'])."]]></cle>\n\t\t";
				$xml .=	"<validation>".plxUtils::cdataCheck($adherent['validation'])."</validation>\n\t\t";
				$xml .=	"<firstDate>".plxUtils::cdataCheck($adherent['firstDate'])."</firstDate>\n\t\t";
				$xml .=	"<date>".plxUtils::cdataCheck($adherent['date'])."</date>\n\t\t";
				if ($this->getParam('typeAnnuaire') == 'professionnel') {
					$xml .= "<activite><![CDATA[".plxUtils::cdataCheck($adherent['activite'])."]]></activite>\n\t\t";
					$xml .= "<etablissement><![CDATA[".plxUtils::cdataCheck($adherent['etablissement'])."]]></etablissement>\n\t\t";
					$xml .= "<service><![CDATA[".plxUtils::cdataCheck($adherent['service'])."]]></service>\n\t\t";
					$xml .= "<tel_office><![CDATA[".plxUtils::cdataCheck($adherent['tel_office'])."]]></tel_office>\n\t";
				}
				if ($this->getParam('showAnnuaire') == 'on') {
					$xml .= "\t<coordonnees><![CDATA[".plxUtils::cdataCheck($adherent['coordonnees'])."]]></coordonnees>\n\t";
				}
				$xml .= "</adherent>\n";
			$xml .= "</document>";

			$time = (empty($adherent['firstDate'])) ? time() : plxUtils::cdataCheck($adherent['firstDate']);

			if (isset($this->plxGlob_adherents->aFiles[$id]) && is_file(PLX_ROOT.$this->getParam('adherents').'adhesions/'.$this->plxGlob_adherents->aFiles[$id])) {
				$fileName = $this->plxGlob_adherents->aFiles[$id];
			} else {
				$fileName = $id.'.'.plxUtils::title2filename(plxUtils::cdataCheck($adherent['nom']).'.'.plxUtils::cdataCheck($adherent['prenom'])).'.'.time().'.xml';
			}
			# On écrit le fichier
			if(plxUtils::write($xml, PLX_ROOT.$this->getParam('adherents').'adhesions/'.$fileName)) {
			//chmod(PLX_ROOT.$this->getParam('adherents').'adhesions/'.$fileName.'.xml',0755);
				if ($mail != array(null) && $mail != NULL) {
					if (is_array($mail)) {
						$action = FALSE;
						foreach ($mail as $key => $m) {
							if (isset($m['notification'])) {//notif adherents
								if ($m['notification']['adherent']['validation'] == '0' || $m['notification']['adherent']['choix'] == 'stop') {
									$pro = array();
									if ($this->getParam('typeAnnuaire') == 'professionnel') {
										$pro['activite'] = $m['notification']['adherent']['activite'];
										$pro['etablissement'] = $m['notification']['adherent']['etablissement'];
										$pro['service'] = $m['notification']['adherent']['service'];
										$pro['tel_office'] = $m['notification']['adherent']['tel_office'];
										if ($this->getParam('showAnnuaire') == 'on') {
											$pro['coordonnees'] = $m['notification']['adherent']['coordonnees'];
										}
									}
									$body = $this->notification(
										$m['notification']['adherent']['nom'],
										$m['notification']['adherent']['prenom'],
										$m['notification']['adherent']['adresse1'],
										$m['notification']['adherent']['adresse2'],
										$m['notification']['adherent']['cp'],
										$m['notification']['adherent']['ville'],
										$m['notification']['adherent']['tel'],
										$m['notification']['adherent']['mail'],
										$m['notification']['adherent']['choix'],
										$m['notification']['adherent']['mailing'],
										$pro
									);
									$this->sendEmail($this->getParam('nom_asso'), $this->getParam('email'), $this->getParam('email'), $m['notification']['sujet'], $body, 'html');
								}
							}
							if($this->sendEmail($m['name'], $m['from'], $m['to'], $m['subject'], $m['body'], $m['contentType'], $m['cc'], $m['bcc'])){
								$action =  TRUE;
							}else{
								$action = FALSE;
							}
						}
						return $action;
					} else {//$mail not array()
						if($this->sendEmail($mail['name'], $mail['from'], $mail['to'], $mail['subject'], $mail['body'], $mail['contentType'], $mail['cc'], $mail['bcc'])){
							return TRUE;
						}else{
							return FALSE;
						}
					}
				} else {//$mail == NULL
					return TRUE;
				}
			} else {//Impossible d'écrire le fichier
				return FALSE;
			}
	}
	/**
	 * Méthode qui édite le fichier XML du plugin adhesion selon le tableau $content
	 *
	 * @param	$content 	array	tableau multidimensionnel du plugin adhesion
	 * @param 	$id 		string 	index de l'adhérent
	 * @param	$action		bool 	permet de forcer la mise à jour du fichier
	 *
	 * @return	string
	 * @author	MAGUIRE Cyril
	 **/
	public function editAdherentslist($content, $id = 0, $action=FALSE) {

		$error = FALSE;
		$success = FALSE;
		$_SESSION['info'] = '';
		$_SESSION['error'] = '';

		if ($id == 0 && empty($content['adherentNum'])) {
			$content['adherentNum'][] = $this->nextIdAdherent();
		}

		// On force la mise à jour
		if($action===TRUE){
			$mail = $this->updateAdherentsList($content);
			if (is_array($mail)) {
				$action = TRUE;
			} else {
				$action = FALSE;
			}
		}
		# suppression
		elseif(!empty($content['selection']) && $content['selection'][0]=='delete' && isset($content['idAdherent'])) {
			$this->deleteAdherentsList($content);
			$action = TRUE;
		}
		# mise à jour de la liste des adhérents
		elseif(isset($content['update']) && $content['update'] == true
			&& ($content['selection'][0]=='validation'
			|| $content['selection'][0]=='devalidation'
			|| $content['selection'][0]=='update'
			)
		){
			foreach ($content['idAdherent'] as $key => $value) {
				if ($content['selection'][0] == 'validation') {
					$content['validation_'.$value] = '1';
				}
				elseif ($content['selection'][0] == 'devalidation') {
					$content['validation_'.$value] = '0';
				}
			}
			$mail = $this->updateAdherentsList($content);
			if (is_array($mail)) {
				$action = TRUE;
			} else {
				$action = FALSE;
			}
		}
		# nouvel enregistrement dans la liste des adhérents depuis l'administration
		elseif( isset($content['new']) && $content['adherentNum'][0] == $content['new']
			&& ( isset($content['choix_'.$content['new']])
			&& $content['choix_'.$content['new']] == 'adhesion'
			)
		){
			$mail = $this->insertNewAdherent($content);
			if (is_array($mail)) {
				$action = TRUE;
				$content['idAdherent'][] = false;
			} else {
				$action = FALSE;
			}
		}
		# nouvel enregistrement dans la liste des adhérents depuis la partie publique
		elseif(isset($content['wall-e']) && empty($content['wall-e']) && $content['choix_'.$id] == 'adhesion'){
			$content['new'] = $id;
			$this->getAdherents('/^[0-9]{5}.(.[a-z-]+){2}.[0-9]{10}.xml$/');
			$mail = $this->insertNewAdherent($content);
			if (is_array($mail)) {
				$action = TRUE;
				$content['idAdherent'][] = false;
			} else {
				$action = FALSE;
			}
		}

		# sauvegarde
		if($action && isset($content['idAdherent'])) {
			foreach ($content['idAdherent'] as $key => $id) {
				$this->recAdherentsList($mail,$id);
			}
		}
		return $action;
	}

	/**
	 * Méthode qui vérifie si un nouvel enregistrement n'est pas déjà présent dans la liste des adhérents
	 *
	 * @param array $adherent tableau contenant les renseignements sur l'enregistrement qui doit être vérifié
	 * @param integer $id index de l'enregistrement en cours
	 *
	 * @return bool
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function isAlreadyExists($adherent,$id) {
		if (!$this->plxRecord_adherents) return FALSE;//Fix 0 adhérant (null) : 1ere inscription
		$verif = $this->plxRecord_adherents->result;
		if(count($verif) > 1){//warn invalid arg for foreach
			$search['nom'] = strtolower($adherent['nom_'.$id]);
			$search['prenom'] = strtolower($adherent['prenom_'.$id]);
			$search['ville'] = strtolower($adherent['ville_'.$id]);
			$search['mail'] = $adherent['mail_'.$id];
			foreach ($verif as $index => $data) {
				if ($search['mail'] == $data['mail']) {
					return TRUE;
				}
				if ($search['nom'] == strtolower($data['nom']) && $search['prenom'] == strtolower($data['prenom']) && $search['ville'] == strtolower($data['ville'])) {
					return TRUE;
				}
			}
		}
		return FALSE;
	}

	/**
	 * Méthode permettant de retrouver le mot de passe associé à un compte
	 *
	 * @param $email string  l'email du compte dont il faut retrouver le mot de passe
	 *
	 * @return string la clé associée au compte
	 * @author Cyril MAGUIRE
	 */
	public function retrieveMyPass($email) {
		foreach ($this->plxRecord_adherents->result as $key => $compte) {
			if ($compte['mail'] == $email) {
				$m = array(
					'name'=>$this->getParam('nom_asso'),
					'from'=>$this->getParam('email'),
					'to'=>$email,
					'subject'=>$this->getParam('subject_password'),
					'body'=>'<p>'.$this->getParam('msg_password').'<br/>'.$compte['cle'].'-'.substr($email,0,-$compte['rand1']).$compte['rand2'].'</p>'.$this->cnil($key,$email),
					'contentType'=>'html',
					'cc'=>FALSE,
					'bcc'=>FALSE
				);//print_r($m);exit();
				if($this->sendEmail($m['name'], $m['from'], $m['to'], $m['subject'], $m['body'], $m['contentType'], $m['cc'], $m['bcc'])){
					return TRUE;
				}else{
					return FALSE;
				}
			}
		}
		return FALSE;
	}

	/**
	 * Méthode permettant d'éditer les paramètres d'un compte adhérent
	 *
	 * @param $compte array tableau des paramètres du compte
	 * @param $id string index du compte dans la liste des adhérents
	 *
	 * @return bool
	 * @author Cyril MAGUIRE
	 */
	public function editMyAccount($compte,$ad) {
		$this->plxMotor = plxMotor::getInstance();
		$this->gutumaPlugin();

		$id = $this->adherentsList[$ad];

		$this->plxRecord_adherents->result[$id]['nom'] = $compte['nom'];
		$this->plxRecord_adherents->result[$id]['prenom'] = $compte['prenom'];
		$this->plxRecord_adherents->result[$id]['adresse1'] = $compte['adresse1'];
		$this->plxRecord_adherents->result[$id]['adresse2'] = $compte['adresse2'];
		$this->plxRecord_adherents->result[$id]['cp'] = $compte['cp'];
		$this->plxRecord_adherents->result[$id]['ville'] = $compte['ville'];
		$this->plxRecord_adherents->result[$id]['tel'] = $this->formatFrenchPhoneNumber($compte['tel']);
		if($this->plxRecord_adherents->result[$id]['mail'] != $compte['mail']){//remove old mail in gutuma list
			$this->removeAdressFromGutumaList($this->plxRecord_adherents->result[$id]['mail'],TRUE);
			$this->plxRecord_adherents->result[$id]['mail'] = $compte['mail'];
			$password = $this->defPassword($ad);//Redéfinition du mot de passe
			$this->plxRecord_adherents->result[$id]['password'] = sha1($this->plxRecord_adherents->result[$id]['salt'].md5($password));
#SEND MAIL with new pass
			$mail = array(
				'name'=>$this->getParam('nom_asso'),
				'from'=>$this->getParam('email'),
				'to'=>$content['mail_'.$id],
				'subject'=>$this->getLang('L_NEW_MAIL_PASS_SUBJECT'),
				'body'=>'<p>'.$this->getLang('L_NEW_MAIL_PASS').'&nbsp;:</p><p>&nbsp;</p><p><strong>'.$password.'</strong></p>'.$this->cnil($id,$content['mail_'.$id]),
				'contentType'=>'html',
				'cc'=>FALSE,
				'bcc'=>FALSE
			);
			$this->sendEmail($mail['name'], $mail['from'], $mail['to'], $mail['subject'], $mail['body'], $mail['contentType'], $mail['cc'], $mail['bcc']);
		}else $this->plxRecord_adherents->result[$id]['mail'] = $compte['mail'];
		$this->plxRecord_adherents->result[$id]['choix'] = $compte['choix'];
		$this->plxRecord_adherents->result[$id]['mailing'] = $compte['mailing'];
		if ($this->getParam('typeAnnuaire') == 'professionnel') {
			if ($compte['activite'] == 'autre') {
				$this->plxRecord_adherents->result[$id]['activite'] = $compte['activite_autre'];
			} else {
				$this->plxRecord_adherents->result[$id]['activite'] = $compte['activite'];
			}
			$this->plxRecord_adherents->result[$id]['etablissement'] = $compte['etablissement'];
			$this->plxRecord_adherents->result[$id]['service'] = $compte['service'];
			$this->plxRecord_adherents->result[$id]['tel_office'] = $compte['tel_office'];
		}
		if ($this->getParam('showAnnuaire') == 'on') {
			$this->plxRecord_adherents->result[$id]['coordonnees'] = $compte['coordonnees'];
		}
		//On ajoute l'email à l'ensemble des mails de la liste de diffusion
		if ($compte['mailing'] == 'maillist') {
			$this->addAdressInGutumaList($compte['mail'],TRUE);
		}
		if ($compte['mailing'] == 'blacklist') {
			$this->removeAdressFromGutumaList($compte['mail'],TRUE);
		}
		if ($compte['choix'] == 'stop') {
			$content['idAdherent'] = array(0 => $ad);
			return $this->deleteAdherentsList($content);
		} else {
			return $this->recAdherentsList(false,$ad);
		}
	}
	///////////////////////////////////////////////////////////
	//
	// Méthodes permettant la gestion des connexions des adhérents
	//
	//////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////
	//
	// Pages dynamiques : catégories et articles
	//
	//////////////////////////////////////////////////////////

	/**
	 * Méthode qui liste tous les mots de passe des adhérents
	 *
	 * @return array
	 * @author Cyril MAGUIRE
	 */
	public function getPasswords() {
		$pw = null;
		//print_r($this->adherentsList);
		if(empty($this->plxRecord_adherents)){
			$this->getAdherents('/^[0-9]{5}.(.[a-z-]+){2}.[0-9]{10}.xml$/');
		}

		foreach ($this->plxRecord_adherents->result as $key => $value) {
			$pw[] = array(
				'rand1' => $value['rand1'],
				'rand2' => $value['rand2'],
				'cle' => $value['cle'],
				'mail' => $value['mail'],
				'salt' => $value['salt'],
				'pass' => $value['password'],
				'nom' => $value['nom'],
				'prenom' => $value['prenom']
			);
		}
		return $pw;
	}

	/**
	 * Méthode qui retourne si l'adhérent est actif (login)
	 *
	 * @return bool
	 * @author Thomas Ingles
	 */
	public function getValidation($login){
		if(!!$this->plxRecord_adherents)
			$this->getAdherents('/^[0-9]{5}.(.[a-z-]+){2}.[0-9]{10}.xml$/');
		foreach ($this->plxRecord_adherents->result as $k => $v)
			if($login == str_replace(array('-','_'),'',plxUtils::title2url(strtolower($v['nom'].$v['prenom'] ))))
				return $v['validation'];
	}

	/**
	 * Méthode qui vérifie si le mot de passe saisi par l'utilisateur est dans la liste des mots de passe
	 * @param $pw string Mot de passe saisi crypté en md5
	 * @param $login string identifiant, correspondant au nom collé au prénom en minuscules sans espace ni caractères accentués ou exotiques
	 *
	 * @return bool
	 * @author Cyril MAGUIRE
	 */
	public function verifPass($pw,$login){
//~		 if(isset($content['wall-e']) && empty($content['wall-e'])) {return FALSE;} && POST
		if(isset($_SESSION['maxtryAdh']) && $_SESSION['maxtryAdh'] >= 3) {
			$_SESSION['timeoutAdh'] = time() + (60*15);
		}
		$error = false;
		$listPass = $this->getPasswords();//print_r($listPass);
		foreach ($listPass as $k => $v) {
			//sha1($salt.md5($cle.'-'.substr($email,0,-$rand1).$rand2))
			$pass = sha1($v['salt'].md5($pw));
			$logInBase = str_replace(array('-','_'),'',plxUtils::title2url(strtolower($v['nom'].$v['prenom'] )));
			if ($pass == $v['pass'] && $login == $logInBase ) {
				$_SESSION['account'] = plxUtils::charAleatoire(5).md5($v['mail']).plxUtils::charAleatoire(3);
				$_SESSION['domainAd'] = $this->session_domain;
				$_SESSION['ValidAd'] = $this->getValidation($login);
				unset($_SESSION['maxtryAdh'],$_SESSION['timeoutAdh']);
				return true;
			}
			if ( ($pass != $v['pass'] && $login == $logInBase) || ($pass == $v['pass'] && $login != $logInBase) ) {
				$error = true;
			}
		}
		if ($error) {
			if(!isset($_SESSION['maxtryAdh'])) {
				$_SESSION['maxtryAdh'] = 1;
			} else{
				$_SESSION['maxtryAdh']++;
			}
		}
		if(!isset($_SESSION['maxtryAdh'])) {
			$_SESSION['maxtryAdh'] = 1;
		} else{
			$_SESSION['maxtryAdh']++;
		}
		return FALSE;
	}

	/**
	 * Méthode qui ajoute le champs 'mot de passe' dans les options des catégories
	 *
	 * @return	stdio
	 * @author	Rockyhorror
	 **/
	public function AdminCategory() {
		echo '<?php
				$password = plxUtils::strCheck($plxAdmin->aCats[$id]["password"]);
				$image = \'&nbsp;<img src="'.PLX_PLUGINS.__CLASS__.'/locker-cat.png" alt="" />\';
			?>';
		echo '<p><label for="id_password">'.$this->getlang('L_CATEGORIE_PASSWORD_FIELD_LABEL').'&nbsp;: <?php if($password == "on") echo $image ?></label>';
		echo '<?php plxUtils::printSelect("password",array(""=>L_NO,"on"=>L_YES),$password); ?></p>';
	}
	public function plxAdminEditCategoriesUpdate(){
		echo '<?php $this->aCats[$cat_id]["password"]=(isset($this->aCats[$cat_id]["password"]) && $this->aCats[$cat_id]["password"] == "on" ? "on" :"") ?>';
	}
	public function plxAdminEditCategoriesNew() {#add new cat pass in article.php
		echo '<?php $this->aCats[$cat_id]["password"] = ""; ?>';
	}
	public function plxAdminEditCategoriesXml() {
		echo '<?php $xml .= "<password><![CDATA[".plxUtils::cdataCheck($cat["password"])."]]></password>"; ?>';
	}
	public function plxAdminEditCategorie() {
		echo '<?php $this->aCats[$content["id"]]["password"] = trim($content["password"]); ?>';
	}
	public function plxMotorGetCategories() {
		echo '<?php $this->aCats[$number]["password"] = isset($iTags["password"][$i]) ? plxUtils::getValue($values[$iTags["password"][$i]]["value"]) : ""; ?>';
	}

	/**
	 * Méthode qui permet de démarrer la bufferisation de sortie sur la page admin/categories.php
	 *
	 * @return	stdio
	 * @author	Stephane F
	 **/
	public function AdminCategoriesTop() {
		echo "<?php ob_start(); ?>";
	}

	/**
	 * Méthode qui affiche l'image du cadenas si la catégorie est protégée par un mot de passe
	 *
	 * @return	stdio
	 * @author	Stephane F, Thomas Ingles
	 **/
	public function AdminCategoriesFoot() {
		echo '<?php '; ?>
		$content=ob_get_clean();
		if(preg_match_all('#idCategory\[\]" value="([0-9]{3})"#', $content, $capture)) {//Multi
			$image = '<img src="<?php echo PLX_PLUGINS.__CLASS__ ?>/locker-cat.png" title="<?php $this->lang('L_CAT_PROTECTED') ?>" />';
			foreach($capture[1] as $idCat) {
				//~ $str = '<td>'.L_CATEGORY.' '.$idCat;// <= 5.3.1
				$str = '</td><td>'.$idCat;// >= 5.4
				if(isset($plxAdmin->aCats[$idCat]['password']) AND $plxAdmin->aCats[$idCat]['password'] == 'on') {
					$content = str_replace($str, $str.' '.$image, $content);
				}
			}
		}
		echo $content;
?><?php
	}

	/**
	 * Méthode qui permet de démarrer la bufferisation de sortie sur la page admin/article.php
	 *
	 * @return	stdio
	 * @author	Stephane F, Thomas Ingles
	 **/
	public function AdminArticleTop() {
		echo "<?php ob_start(); ?>";
	}

	/**
	 * Méthode qui affiche une icone aux catégories dédiées aux adhérents (sidebar)
	 *
	 * @return	stdio
	 * @author	Stephane F, Thomas Ingles
	 **/
	public function AdminArticleFoot() {
		echo '<?php '; ?>
		$content=ob_get_clean();
		if(preg_match_all('#label for="cat_([0-9]{3})"#', $content, $capture)) {
			$image = '&nbsp;<img src="<?php echo PLX_PLUGINS.__CLASS__ ?>/locker-cat.png" title="<?php $this->lang('L_CAT_PROTECTED') ?>" />';
			foreach($capture[1] as $idCat) {
//~ 				$str = '<label for="cat_'.$idCat.'">';
				$str = ' value="'.$idCat.'" />';
				if(isset($plxAdmin->aCats[$idCat]['password']) AND $plxAdmin->aCats[$idCat]['password'] == 'on') {
					$content = str_replace($str, $str.$image, $content);
				}
			}
		}
		echo $content;
?><?php
	}

	/**
	 * Méthode qui ajoute le champ 'mot de passe' dans l'édition de l'article
	 *
	 * @return	stdio
	 * @author	Rockyhorror
	 **/
	public function AdminArticleSidebar(){
		echo '<?php $image = \'&nbsp;<img src="'.PLX_PLUGINS.__CLASS__ .'/locker.png" alt="" />\'; ?>';
		echo '<p><label for="id_password">'.$this->getlang('L_ARTICLE_PASSWORD_FIELD_LABEL').'&nbsp;: <?php if($password == "on") echo $image ?></label>';
		echo '<?php plxUtils::printSelect("password",array(""=>L_NO,"on"=>L_YES),$password); ?></p>';
	}
	public function plxAdminEditArticleXml(){
		echo '<?php $xml .= "\t"."<password><![CDATA[".plxUtils::cdataCheck(trim($content["password"]))."]]></password>"."\n"; ?>';
	}
	public function plxMotorParseArticle(){
		echo '<?php $art["password"] = (isset($iTags["password"]) && isset($values[ $iTags["password"][0] ]) )?trim(plxUtils::getValue($values[ $iTags["password"][0] ]["value"]) ):""; ?>';
	}
	public function AdminArticlePostData(){//Nvelle cat article.php
		echo '<?php $password = $_POST["password"]; ?>';
	}
	public function AdminArticleContent(){//affiche l'icone si l'article est privé (cat ou lui même)
		echo '<?php '; ?>
			$selCatPass = '';
			$image = ($password?'<sup><img class="float-left" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/locker.png" title="<?php $this->lang('L_ART_PROTECTED') ?>"><?php $this->lang('L_ART_PROTECTED') ?></sup>':'');
			$imagecat = '<sup><img class="float-left" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/locker-cat.png" title="<?php $this->lang('L_CAT_PROTECTED') ?>"><?php $this->lang('L_CAT_PROTECTED')?></sup>';
			foreach($plxAdmin->aCats as $cat_id => $cat) {
				if($cat['password']){
					$selCatPass = (is_array($catId) AND in_array($cat_id, $catId)) ? ($password?'<br />':'').$imagecat : '';
					if($selCatPass) break;//locked (4 no lost if pass next but unselected)
				}
			}
			if($password OR $selCatPass) echo '<div class="float-right alert green"><sup class="float-center"><?php $this->lang('L_ADHESIONS') ?> : <?php $this->lang('L_FORM_MEMBERS') ?></sup><img class="float-none" src="<?php echo PLX_PLUGINS.__CLASS__ ?>/icon.png" title="<?php $this->lang('L_ADHESIONS') ?>"><br />'.$image.$selCatPass.'</div>';
?><?php
	}
	public function AdminArticleInitData(){
		echo "<?php \$password = ''; ?>";
	}
	public function AdminArticleParseData(){
		echo "<?php \$password = \$result['password']; ?>";
	}
	/**
	 * Méthode qui affiche un cadenas si l'article a un mot de passe ::: est inutilisé
	 *
	 * @return	stdio
	 * @author	Rockyhorror
	 **/
	public function showIconIfLock() {
		$artPassword = $this->plxMotor->plxRecord_arts->f('password');
		if(!empty($artPassword)){
			$string = '<?php echo "<img src=\"'.PLX_PLUGINS.__CLASS__.'/locker.png\">"; ?>';
			echo $string;
		}
	}

	/**
	 * Méthode qui masque les commentaires
	 * Note : in hooks plx(Motor|Feed)PreChauffageEnd()
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	private function hideComs() {
		echo '<?php '; ?>
#strpos($this->mode,'_password') === FALSE en loupe if $this->mode != '###_password' ::: article commentaire & tag
		if(isset($_SESSION['lockArticles']))//si connecté : ds feed, tjrs actif :: $_SESSION['lockArticles'] non activé
			return;
#Coms All verif
			foreach($this->plxGlob_coms->aFiles as $key => $comFilename) {
				$fileInfo = $this->comInfoFromFilename($comFilename);
				$artInfo = $this->artInfoFromFilename($this->plxGlob_arts->aFiles[$fileInfo['artId']]);
				$cats = explode(',',$artInfo['catId']);
				foreach($cats AS $cat){
					if($cat=='draft' OR $cat=='000' OR $cat=='home')continue;// Fix: Notice: Undefined index : Catégorie virtuelles et brouillon (non gérable par le plugin)
					if(!empty($this->aCats[$cat]['password'])) {
						unset ($this->plxGlob_coms->aFiles[$key]);
						continue(1);
					}
				}
#Art solo verif
				$root = PLX_ROOT.$this->aConf["racine_articles"];//ok multilingue
				$art = $this->parseArticle($root.$this->plxGlob_arts->aFiles[$fileInfo['artId']]);
				if(isset($art['password']) AND !empty($art['password']))
					unset ($this->plxGlob_coms->aFiles[$key]);
			}
?><?php
	}

	/**#unused! Improve & HideStat
	 * Méthode qui masque les articles d'une catégorie
	 *
	 * @author Cyril MAGUIRE
	 */
	private function hideArts($catId='') {#unused? OUI
		foreach($this->plxMotor->plxGlob_arts->aFiles as $key => $artFilename){
			$fileInfo = $this->plxMotor->artInfoFromFilename($artFilename);
			$catPassword = $this->plxMotor->aCats[$fileInfo['catId']]['password'];
			if(!empty($catPassword)) {
//				if(($fileInfo['catId'] != $catId) &&  !isset($_SESSION['lockArticles']['categorie'][$fileInfo['catId']])){
				if(($fileInfo['catId'] != $catId) &&  !isset($_SESSION['lockArticles']['categorie'])){
					unset ($this->plxMotor->plxGlob_arts->aFiles[$key]);
				}
//				elseif (!isset($_SESSION['lockArticles']['categorie'][$fileInfo['catId']])) {
				elseif (!isset($_SESSION['lockArticles']['categorie'])) {
					unset ($this->plxMotor->plxGlob_arts->aFiles[$key]);
				}
			}
		}
	}

	/**
	 * Méthode qui redefinit les modes de plxMoto
	 * @scope : art,homes,cat,tag&arch
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxMotorPreChauffageEnd() {
		$this->plxMotor = plxMotor::getInstance();
		$this->hideComs();
		if($this->plxMotor->mode=='article') {
#			ob_start();echo $this->plxMotor->plxRecord_arts->f('password');$password = ob_get_clean();#ok::Origin
#			$password = plxUtils::getValue($this->plxMotor->plxRecord_arts->f('password'));//Strict standards: Only variables should be passed by reference
			$password = $this->plxMotor->plxRecord_arts->f('password');#2.0.0 (intest)
			if(empty($password)) {#cat verif if artpass not
				$cat_id = explode(',',$this->plxMotor->plxRecord_arts->f('categorie'));
				foreach ($cat_id as $key => $value) {
					if (!empty($this->plxMotor->aCats[$value]['password'])) {
						$password = plxUtils::getValue($this->plxMotor->aCats[$value]['password']);
						break;
					}
				}
			}
			if(!empty($password)) {
				if(!isset($_SESSION['lockArticles']['articles'])) {
					$this->plxMotor->mode = 'article_password';
				}
			}
			else {
				$cat_id = $this->plxMotor->plxRecord_arts->f('categorie');
				if(!empty($this->plxMotor->aCats[$cat_id]['password'])) {
					if(!isset($_SESSION['lockArticles']['categorie'])) {
						$this->plxMotor->mode = 'categorie_password';
					}
				}
			}
		}
#		elseif($this->plxMotor->mode == 'categorie') {}
		elseif($this->plxMotor->mode == 'archives' OR $this->plxMotor->mode == 'tags') {
			$this->plxMotor->getArticles();
			if($this->plxMotor->plxRecord_arts){//have arts?
				foreach ($this->plxMotor->plxRecord_arts->result as $key => $art) {
					$cat_id = explode(',',$art['categorie']);
					foreach ($cat_id as $key => $value) {
						if(!empty($this->plxMotor->aCats[$value]['password']) && !isset($_SESSION['lockArticles']['categorie'])) {
#							$this->plxMotor->mode = 'home';#remove tag in link url feed
#							$this->plxMotor->mode = 'tags_password';#Fix link url feed
							$this->plxMotor->mode = $this->plxMotor->mode . '_password';#Fix link url feed
							return;#stop loop #Fix (tag|archives)_password_password
						}
					}
				}
			}
		}
	}

	/**
	 * Méthode qui permet la (dé)conexion en empechant de poster un commentaire (en mode article)
	 *# Hook plugins
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function plxMotorDemarrageBegin() {
		if(isset($_POST['logout']) OR isset($_POST['login']) OR isset($_POST['password']))//(Dé)Connexion
			echo '<?php $this->aConf["allow_com"] = 0; ?>';//empeche de commenter dans le vide lors de cnx & décnx [$_post] v5.6
	}

	/**
	 * Méthode qui affiche le formulaire de saisie du mot de passe
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function plxMotorDemarrageEnd() {
		if(empty($this->plxMotor))
			$this->plxMotor = plxMotor::getInstance();
		if(isset($_POST['forgetmypass'])//Mot de passe oublié, (retrieveMyPass)
		AND (isset($_POST['wall-e']) AND empty($_POST['wall-e']))) {//no wall-e
			$error = '';
			if(!plxUtils::checkMail($_POST['email']))
				$error .= $this->getLang('L_ERR_MAIL').'! ';
			if (isset($this->plxMotor->plxPlugins->aPlugins['plxCapchaImage']))//si capchaImage
				$_SESSION['capcha']=sha1($_SESSION['capcha']);
			if($this->plxMotor->aConf['capcha'] AND $_SESSION['capcha'] != sha1($_POST['rep']))
				$error .= $this->getLang('L_ERR_ANTISPAM').'! ';
			$noerror = empty($error);
			if($noerror AND $this->retrieveMyPass(plxUtils::strCheck($_POST['email']))) {//si ok : on renvoie la clé si l'email correspond
				$_SESSION['retrievePass']['m'] = '<p id="password_success">'.$this->getLang('L_EMAIL_PASS_OK').'</p>';
				$_SESSION['retrievePass']['d'] = 's';
				header('Location:'.$this->plxMotor->urlRewrite() );//retour a l'accueil
				exit;
			} else {
				$_SESSION['retrievePass']['m'] = '<p id="password_error">'.(!$noerror?$error:$this->getLang('L_EMAIL_PASS_KO')).'</p>';
				$_SESSION['retrievePass']['d'] = 'e';
			}
		}

		if(isset($_POST['logout'])) {//Déconnexion
			//On supprime les index de session
			unset($_SESSION['lockArticles'], $_SESSION['account'], $_SESSION['domainAd'], $_SESSION['maxtryAdh'], $_SESSION['timeoutAdh']);
			$_SESSION['logout'] = $this->getlang('L_DECONNEXION_OK');
			header('Location:'.$this->plxMotor->racine.$this->plxMotor->path_url);
			exit;
		}

		$this->session_domain = str_replace(PLX_PLUGINS.__CLASS__,'',dirname(__FILE__));//Définition du domaine initial
		//Si le mode est protégé, on affiche le message de connexion, sinon on affiche la page normalement
		switch ($this->plxMotor->mode) {
			case 'static_password':
			case 'article_password':
			case 'categorie_password':
			//~ case 'categories_password':
			case 'annuaire':
				$showForm = TRUE;
			break;
			case 'home':
			case 'categorie':
			case 'tags_password':#exist? UTILE?
			case 'archives_password':
				$this->plxMotor->mode = str_replace('_password','',$this->plxMotor->mode);
				$protectedCats = array();
				foreach($this->plxMotor->plxGlob_arts->aFiles as $key => $artFilename){
					$fileInfo = $this->plxMotor->artInfoFromFilename($artFilename);
					$cats = explode(',', $fileInfo['catId']);
					$catPassword = '';
					foreach ($cats as $k => $value) {
						if ($value>0 && $this->plxMotor->aCats[$value]['password'] == 'on') {//$value>0  solve Notice: Undefined index: 000 (home exist in recent version?)
							$catPassword = $this->plxMotor->aCats[$value]['password'];
							if($catPassword == 'on') {
								$protectedCats[] = $fileInfo['catId'];
							}
							$catPassword = '';
						}
					}
				}

				if (!isset($_SESSION['lockArticles']['categorie'])) {
					foreach ($this->plxMotor->plxRecord_arts->result as $k => $data) {
						if ( ($data['password'] == 'on' ) OR in_array($data['categorie'],$protectedCats) ) {//thumbnail
							$this->plxMotor->plxRecord_arts->result[$k]['chapo'] = '';
							$this->plxMotor->plxRecord_arts->result[$k]['nb_com'] = 0;
							$this->plxMotor->plxRecord_arts->result[$k]['allow_com'] = 0;
							$this->plxMotor->plxRecord_arts->result[$k]['thumbnail'] = '';
							$this->plxMotor->plxRecord_arts->result[$k]['content'] = '<p class="locked">'.sprintf($this->getLang('L_NEED_AUTH'),$this->plxMotor->urlRewrite('?adhesion.html'),$this->getParam('mnuAdhesion')).'</p>'.$this->finclude(PLX_PLUGINS.__CLASS__.'/form.login.inc.php',false,'aside');//categorie
						}
					}
				}
				$showForm = FALSE;
				break;
			default:
				$showForm = FALSE;
		}//FI SWITCH motor mode

		if(isset($_POST['lockArticles']) AND isset($_POST['password']) AND isset($_POST['login'])//Vérification de la connexion
		AND (isset($_POST['wall-e']) AND empty($_POST['wall-e']))) {//no wall-e
			if($this->verifPass($_POST['password'],plxUtils::strCheck($_POST['login']))) {
				$_SESSION['lockArticles']['articles'] = $_SESSION['lockArticles']['categorie'] = 'on';
				$_SESSION['lockArticles']['success'] = $this->getlang('L_CONNEXION_OK');
				$showForm = FALSE;
#				$url = $this->plxMotor->urlRewrite('?'.$this->plxMotor->mode);//fix notice on error mode line:2822 ($url undefined)
				switch ($this->plxMotor->mode) {
#					case 'article_password':
#					case 'categorie_password':
#					case 'categories_password':
#					case 'static_password':
#					case 'tags_password':
					case 'annuaire':
					case 'adhesion':#HISTORIC
					case __CLASS__:
						header('Location:'.$this->plxMotor->urlRewrite('?'.($this->getParam('showAnnuaire')!='on'?'myaccount':'annuaire').'.html'));//on redirige (vers mon compte si l'annuaire est désactivé)
						exit;
					case 'categorie':
					case 'home':
#					case 'tags':
						foreach ($this->plxMotor->plxRecord_arts->result as $key => $value) {
							if(isset($value['password']) && $value['password'] == 'on' && !isset($_SESSION['lockArticles']['categorie']) && !isset($_SESSION['lockArticles']['articles']) ) {
								//On modifie le contenu de l'article
								$a = array();
								$a['chapo'] = '';
								$a['nb_com'] = 0;
								$a['allow_com'] = 0;
								$a['thumbnail'] = '';
								$a['content'] = '<p class="locked">'.sprintf($this->getLang('L_NEED_AUTH'),$this->plxMotor->urlRewrite('?adhesion.html'),$this->getParam('mnuAdhesion')).'</p>'.$this->finclude(PLX_PLUGINS.__CLASS__.'/form.login.inc.php',false,'aside');//categorie, home, article

								$this->plxMotor->plxRecord_arts->result[$key] = array_merge($this->plxMotor->plxRecord_arts->result[$key], $a);
							}
						}
				}//Fi switch plxMotor->mode
				header('Location:'.$this->plxMotor->racine.$this->plxMotor->path_url);#header('Location:'.$url);//on redirige
				exit;
			}//FI LOGIN OK
			else {//BAD LOGIN
				if (isset($_SESSION['maxtryAdh']) && $_SESSION['maxtryAdh'] >= 3) {
					$_SESSION['timeoutAdh'] = time() + (60*15);
					$_SESSION['erase']['m'] = '<p id="password_error">'.$this->getlang('L_PLUGIN_MAXTRY').'&nbsp;'.date('H\hi',(60+$_SESSION['timeoutAdh'])).'</p>';
					$_SESSION['erase']['d'] = 'e';//display what
				} else {
					$_SESSION['lockArticles']['error'] = $this->getlang('L_PLUGIN_BAD_PASSWORD');
				}
			}//FI LOGIN OK & BAD LOGIN
		}//FI Vérification de la connexion

		if (isset($_SESSION['domainAd']) && $_SESSION['domainAd'] != $this->session_domain) {
			$showForm = TRUE;
			unset($_SESSION['domainAd']);
		}

		if($showForm) {
			$a = array();
			$a['content'] = '<p class="locked">'.sprintf($this->getLang('L_NEED_AUTH'),$this->plxMotor->urlRewrite('?adhesion.html'),$this->getParam('mnuAdhesion')).'</p>'.$this->finclude(PLX_PLUGINS.__CLASS__.'/form.login.inc.php',false,'aside');//article
			if(isset($_SESSION['lockArticles']['error'])) {
				$a['content'] .= '<p class="static_password_error">'.$_SESSION['lockArticles']['error'].'</p>';
				unset($_SESSION['lockArticles']['error']);
			}
			$a['nb_com'] = 0;
			$a['allow_com'] = 0;
			$a['chapo'] = '';
			$a['thumbnail'] = '';
			if($this->plxMotor->plxRecord_arts) {
				$this->plxMotor->plxRecord_arts->result[0] = array_merge($this->plxMotor->plxRecord_arts->result[0], $a);
				if ($this->plxMotor->mode != 'annuaire') {
					$this->plxMotor->template = $this->plxMotor->plxRecord_arts->f('template');
				}
			}
		}
	}

	/**
	 * Méthode qui inclus le formulaire de connexion
	 * Voir L_NEED_AUTH ou lockarticles
	 *
	 * @return string if $echo true inc on called moment
	 * @author Thomas Ingles
	 */
	public function finclude($what,$echo=false,$class=false) {#var_dump(__CLASS__.' '.__FUNCTION__,$what,$echo,$class,$BUG);
		if(!$echo)ob_start();
		@include($what);
		if(!$echo)return ob_get_clean();
}

	/**
	 * Méthode qui affiche le bouton de déconnexion et le formulaire de connexion
	 * Voir $this->ThemeEndBody pour l'affichage des messages
	 *
	 * @return string
	 * @author Cyril MAGUIRE
	 */
	public function loginLogout() {//TODO Wall-e + capcha? for login (OR add func in this class)
		if ((isset($_SESSION['domain']) AND $_SESSION['domain'] == $this->session_domain) || (isset($_SESSION['lockArticles']['categorie']) && $_SESSION['lockArticles']['categorie'] == 'on') || (isset($_SESSION['lockArticles']['articles']) && $_SESSION['lockArticles']['articles'] == 'on') ) {
			if (isset($_SESSION['timeoutAdh']) ) {
				unset($_SESSION['timeoutAdh']);
			}
		}//unset($_SESSION['maxtryAdh'],$_SESSION['timeoutAdh']);// to debug
		if (isset($_SESSION['timeoutAdh']) ) {
			unset($_SESSION['lockArticles']);
			if (time() < $_SESSION['timeoutAdh'] ) {
				$this->finclude(PLX_PLUGINS.__CLASS__.'/form.login.inc.php',true);#echo cnx form trop d'essais + time out notice + renvoi pass
			} else {
				unset($_SESSION['maxtryAdh']);
				unset($_SESSION['timeoutAdh']);
				header('Location:'.$this->plxMotor->racine.$this->plxMotor->path_url);//header('Location:'.$this->plxMotor->urlRewrite());
				exit();
			}
		} else {
			if ( (isset($_SESSION['domain']) AND $_SESSION['domain'] == $this->session_domain) || (isset($_SESSION['lockArticles']['categorie']) && $_SESSION['lockArticles']['categorie'] == 'on') || (isset($_SESSION['lockArticles']['articles']) && $_SESSION['lockArticles']['articles'] == 'on') ) {
				$this->finclude(PLX_PLUGINS.__CLASS__.'/form.logout.inc.php',true);#echo Space member form
			} else {
				$this->finclude(PLX_PLUGINS.__CLASS__.'/form.login.inc.php',true);#echo login | oops pass form
			}
		}
	}

	/**
	 * Méthode qui enclanche la bufferisation de sortie pour afficher les cadenas (voir AdminIndexFoot())
	 *
	 * @author Cyril MAGUIRE
	 */
	public function AdminIndexTop (){
		echo "<?php ob_start(); ?>";
	}

	/**
	 * Méthode qui affiche le cadenas au niveau de la page articles de l'administration si un article a un mot de passe
	 *
	 * @author Cyril MAGUIRE
	 */
	public function AdminIndexFoot () {
		echo '<?php '; ?>
			$content=ob_get_clean();
			if(preg_match_all("#value=\"([0-9]{4})\"#", $content, $capture)) {//origin
#			if(preg_match_all("#</td><td>([0-9]{4})</td><td>#", $content, $capture)) {//idée ok
				$image = '<img style="max-width: none;" src="<?php echo PLX_PLUGINS.get_class($this) ?>/locker.png" title="<?php $this->lang('L_ART_PROTECTED')?>">';
				$imagecat = '<img style="max-width: none;" src="<?php echo PLX_PLUGINS.get_class($this) ?>/locker-cat.png" title="<?php $this->lang('L_CAT_PROTECTED')?>">';
				$artTab = array();
				$artTabCat = array();
				while($plxAdmin->plxRecord_arts->loop()) {
					$art_id = $plxAdmin->plxRecord_arts->f('numero');
					$cat_id = explode(',',$plxAdmin->plxRecord_arts->f('categorie'));
					$artTab[$art_id] = $plxAdmin->plxRecord_arts->f('password');
					foreach ($cat_id as $key => $value) {
						if (!empty($plxAdmin->aCats[$value]['password'])) {
							$artTabCat[$art_id] = $plxAdmin->aCats[$value]['password'];
						}
					}
				}
				foreach($capture[1] as $ArtId) {
					$adImg = "";
					if(!empty($artTab[$ArtId]))// && empty($artTabCat[$ArtId])
						$adImg .= $image;
					if(!empty($artTabCat[$ArtId]))
						$adImg .= $imagecat;
#					$str = '<td><a href="article.php?a='.$ArtId.'" title="";//on links edit
#					$content = str_replace($str.L_ARTICLE_EDIT_TITLE.'>', $str, $content);//on links edit
#					$content = str_replace($str, $str.L_ARTICLE_EDIT_TITLE.'>'.$adImg.'&nbsp;', $content);//on links edit
					$str = '</td><td>'.$ArtId;
					$content = str_replace($str, $str.$adImg, $content);
				}
			}
			echo $content;
?><?php
	}

	/**
	 * Méthode permettant de masquer s'il y a un mot de passe
	 *
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function plxFeedPreChauffageEnd() {
		$this->plxMotor = plxFeed::getInstance();
		if ($this->plxMotor->mode == 'commentaire') {
			$this->hideComs();
		}
		echo '<?php '; ?>
		switch($this->mode) {
			case 'tag':
			case 'article' : $this->mode = $this->mode.'_password';break;//$this->getRssArticles(); break;
			//case 'commentaire' : $this->getRssComments(); break;
			//case 'admin' : $this->getAdminComments(); break;
			default : break;
		}
?><?php
	}

	/**
	 * Méthode qui permet d'afficher un article dans le flux RSS s'il n'est pas protégé par un mot de passe
	 * Note : $_SESSION : only langs : $_SESSION['lockArticles'] unexist here
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function plxFeedDemarrageBegin() {
		echo '<?php '; ?>
		if(strpos($this->mode,'_password') === FALSE)//if ($this->mode != '###_password' ::: article commentaire & tag
			return;
		$this->mode = str_replace('_password','',$this->mode);//goto ORIGIN mode (no trouble of PluXml Motor ;)
		# Flux de commentaires d'un article précis
		if($this->mode == 'commentaire' AND $this->cible) {
			if(!$this->getArticles()) { # Aucun article, on redirige
				$this->cible = $this->cible + 0;
				header('Location:'.$this->urlRewrite('?article'.$this->cible.'/'));
				exit;
			} else { # On récupère les commentaires
				$regex = '/^'.$this->cible.'.[0-9]{10}-[0-9]+.xml$/';
				$this->getCommentaires($regex,'rsort',0,$this->bypage);
			}
		}
		# Flux de commentaires global
		elseif($this->mode == 'commentaire') {
			$regex = '/^[0-9]{4}.[0-9]{10}-[0-9]+.xml$/';
			$this->getCommentaires($regex,'rsort',0,$this->bypage);
		}
		# Flux admin
		elseif($this->mode == 'admin') {
			if(empty($this->clef)) { # Clef non initialisée
				header('Content-Type: text/plain; charset='.PLX_CHARSET);
				echo L_FEED_NO_PRIVATE_URL;
				exit;
			}
			# On récupère les commentaires
			$this->getCommentaires('/^'.$this->cible.'[0-9]{4}.[0-9]{10}-[0-9]+.xml$/','rsort',0,$this->bypage,'all');
		}
		# Flux d'articles pour un tag
		elseif($this->mode == 'tag') {
			if(empty($this->motif)) {
				header('Location:'.$this->urlRewrite('?tag/'.$this->cible.'/'));
				exit;
			} else {
				$this->getArticles(); # Récupération des articles (on les parse)
			}
		}
		# Flux d'articles
		else {
			if($this->cible) {# Flux des articles d'une catégorie précise
				# On va tester la catégorie
				if(empty($this->aCats[$this->cible]) OR !$this->aCats[$this->cible]['active']) { # Pas de catégorie, on redirige
					$this->cible = $this->cible + 0;
					header('Location:'.$this->urlRewrite('?categorie'.$this->cible.'/'));
					exit;
				}
			}
			$this->getArticles(); # Récupération des articles (on les parse)
		}
		if($this->plxRecord_arts) {
			while($this->plxRecord_arts->loop()) {
				$password = $this->plxRecord_arts->f('password');
				$category = $this->plxRecord_arts->result[$this->plxRecord_arts->i]['categorie'];
				$cats = explode(',',$category);
				foreach($cats AS $cat){
					if($cat=='draft' OR $cat=='000' OR $cat=='home')continue;//warn : Cat virtuelles et brouillon (non gérable par le plugin)
					$catPassword = $this->aCats[$cat]['password'];
					if(!empty($catPassword)) {
						$password = 'on';
						continue;
					}
				}
				if(!empty($password)) {#clear all fields
					$this->plxRecord_arts->result[$this->plxRecord_arts->i]['chapo'] = '';
					$this->plxRecord_arts->result[$this->plxRecord_arts->i]['nb_com'] = 0;
					$this->plxRecord_arts->result[$this->plxRecord_arts->i]['allow_com'] = 0;
					$this->plxRecord_arts->result[$this->plxRecord_arts->i]['thumbnail'] = '';
					$this->plxRecord_arts->result[$this->plxRecord_arts->i]['content'] = '<p class="locked"><?php sprintf($this->getLang('L_NEED_AUTH'),$this->plxMotor->urlRewrite('?adhesion.html'),$this->getParam('mnuAdhesion'))?></p>';
				}
			}
			$this->getRssArticles();#DISPLAY THIS
			return true;#STOP HERE! : getArticles() RELOAD arts with real data AFTER
		}
?><?php
	}

	///////////////////////////////////////////////////////////
	//
	// Pages statiques
	//
	//////////////////////////////////////////////////////////

	/**
	 * Méthode qui ajoute le champ de saisie du mot de passe dans la page d'édition de la page statique
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function AdminStatic() {
		echo '<?php '; ?>
			if(!$id AND !empty($_GET['p'])) # On affiche le contenu de la page
				$id = plxUtils::strCheck(plxUtils::nullbyteRemove($_GET['p']));//fix IF plxMML LOADED BEFORE, HAVE IN HOOK $id = $ title = '';   ?
			$password = plxUtils::getValue($plxAdmin->aStats[$id]["password"]);
			$image = '&nbsp;<img src="<?php echo PLX_PLUGINS.__CLASS__ ?>/locker.png" alt="" />';
?>
			<fieldset>
				<p><label for="id_password"><?php echo $this->getLang('L_FORM_ADMIN_PASSWORD') ?>&nbsp;: <?php echo '<?php if($password == "on") echo $image ?>'; ?></label>
				<?php echo '<?php plxUtils::printSelect("password",array(""=>L_NO,"on"=>L_YES),$password); ?>'; ?></p>
			</fieldset>
<?php
	}

	/**
	 * Méthode qui ajoute la notification de mot de passe dans la chaine xml à sauvegarder dans statiques.xml
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxAdminEditStatiquesXml() {
		echo '<?php '; ?>
		$xml .= '<password><![CDATA['.plxUtils::cdataCheck(@$static['password']).']]></password>';
?><?php
	}

	/**
	 * Méthode qui récupère la notification de mot de passe saisit lors de l'édition de la page statique
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxAdminEditStatique() {
		echo '<?php '; ?>
		$this->aStats[$content['id']]['password'] = (!empty($content['password']) ? 'on' : '');//FALSE
?><?php
	}

	/**
	 * Méthode qui récupère la notification de mot de passe stockée dans le fichier xml statiques.xml
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxMotorGetStatiques() {
		echo '<?php '; ?>
		$password = plxUtils::getValue($iTags['password'][$i]);
		$this->aStats[$number]['password']=plxUtils::getValue($values[$password]['value']);
?><?php
	}

	/**
	 * Méthode qui permet de démarrer la bufferisation de sortie sur la page admin/statiques.php
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function AdminStaticsTop() {
		echo "<?php ob_start(); ?>";
	}

	/**
	 * Méthode qui affiche l'image du cadenas si la page est protégée par un mot de passe
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function AdminStaticsFoot() {
		echo '<?php '; ?>
		$content=ob_get_clean();
//		 if(preg_match_all("#<td>".L_PAGE." ([0-9]{3})</td>#", $content, $capture)) {// <= 5.3.1
//		 if(preg_match_all("#</td><td>([0-9]{3})</td><td>#", $content, $capture)) {// >= 5.4
		if(preg_match_all('#idStatic\[\]" value="([0-9]{3})"#', $content, $capture)) {//Multi
			$image = '<img src="<?php echo PLX_PLUGINS.get_class($this)?>/locker.png" title="<?php $this->lang('L_PGS_PROTECTED')?>" />';
			foreach($capture[1] as $idStat) {
//				 $str = "<td>".L_PAGE." ".$idStat;//5.2
				$str = "</td><td>".$idStat;
				if(isset($plxAdmin->aStats[$idStat]["password"]) AND $plxAdmin->aStats[$idStat]["password"] == 'on') {
					$content = str_replace($str, $str." ".$image, $content);
				}
			}
		}
		echo $content;
?><?php
	}

	/**
	 * Méthode qui protege les pages statiques si mode static_password : si page protégée url = static_password
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxShowConstructStat() {
		# infos sur la page statique
		echo '<?php '; ?>
		if($this->plxMotor->mode=='static_password') {
			$array = array();
			$array[$this->plxMotor->cible] = array(
			'name'		=> $this->plxMotor->aStats[$this->plxMotor->idStat]['name'],
			'menu'		=> '',
			'url'		=> 'static_password',
			'readable'	=> 1,
			'active'	=> 1,
			'group'		=> ''
		);
			$this->plxMotor->aStats = array_merge($this->plxMotor->aStats, $array);
		}
?><?php
	}

	/**
	 * Méthode qui affiche le formulaire d'identification si un mot de passe est présent pour la page statique
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function plxMotorPreChauffageEndStat() {
		$cible = (defined('PLX_MYMULTILINGUE')?'../':'').'../../'.PLX_PLUGINS.__CLASS__.'/form';
		echo '<?php '; ?>
		if($this->mode=='static') {
			$password = plxUtils::getValue($this->aStats[$this->cible]['password']);
			if($password=='on') {
				if(!isset($_SESSION['lockArticles']['categorie'])) {
					$this->idStat = $this->cible;
					$this->cible = '<?php echo $cible ?>';
					$this->mode = 'static_password';
					$this->template = 'static.php';
				}
			}
		}
?><?php
	}


	/**
	 * Méthode qui valide la connexion d'un adhérent
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function plxMotorDemarrageEndStat(){
		if($this->plxMotor->mode == 'static' || $this->plxMotor->mode == 'static_password') {
			if(isset($_POST['lockArticles']) AND isset($_POST['password']) AND isset($_POST['login'])) {
				if ($this->verifPass($_POST['password'],plxUtils::strCheck($_POST['login']))) {
					$_SESSION['lockArticles']['categorie'] = $_SESSION['lockArticles']['articles'] = 'on';
					$url = $this->plxMotor->urlRewrite('?'.$this->plxMotor->aCats[$this->plxMotor->cible]['url']);
					$_SESSION['lockArticles']['success'] = $this->getlang('L_CONNEXION_OK');
					header('Location:'.$url);
					exit;
				}
				else {
					$_SESSION['lockArticles']['error'] = $this->getlang('L_PLUGIN_BAD_PASSWORD');
				}
			}
		}
	}

	/**
	 * Méthode qui renseigne le titre de la page dans la balise html <title> des statiques avec MDP
	 *
	 * @return	stdio
	 * @author	Stephane F
	 **/
	public function plxShowPageTitleStat() {
		echo '<?php '; ?>
			if($this->plxMotor->mode == "static_password") {
				echo plxUtils::strCheck($this->plxMotor->aConf["title"])." - ".plxUtils::strCheck($this->plxMotor->aStats[$this->plxMotor->idStat]["name"]);
				return TRUE;
			}
?><?php
	}

	/**
	 * Méthode qui ajoute le fichier style-lock.css dans le fichier header.php du thème
	 *
	 * @return	stdio
	 * @author	Stephane F
	 **/
	public function ThemeEndHeadStat() {
		if(isset($_SESSION['lockArticles'])) return;
?>	<link rel="stylesheet" type="text/css" href="<?php echo PLX_PLUGINS.__CLASS__ ?>/style-lock.css" media="screen" />
<?php
	}

	/**
	 * Méthode qui affiche des messages succes/erreur
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function ThemeEndBody() {
		$js=0;
		if (isset($_SESSION['lockArticles']['success']) && $_SESSION['lockArticles']['success'] == $this->getlang('L_CONNEXION_OK') ) {
			if (!isset($_SESSION['lockArticles']['log'])) {
				echo '<p id="password_success">'.$this->getLang('L_CONNEXION_OK').'</p>';
				$js='s';
				unset($_SESSION['lockArticles']['success']);
			}
		}
		if (isset($_SESSION['logout']) && $_SESSION['logout'] == $this->getlang('L_DECONNEXION_OK')) {
			echo '<p id="password_success">'.$this->getLang('L_DECONNEXION_OK').'</p>';
			$js='s';
			unset($_SESSION['logout']);
		}
		if (isset($_SESSION['lockArticles']['error']) && $_SESSION['lockArticles']['error'] == $this->getlang('L_PLUGIN_BAD_PASSWORD')) {
			echo '<p id="password_error">'.$_SESSION['lockArticles']['error'].'</p>';
			$js='e';
			unset($_SESSION['lockArticles']['error']);
		}
		if (isset($_SESSION['retrievePass'])) {
			echo $_SESSION['retrievePass']['m'];//message
			$js=$_SESSION['retrievePass']['d'];//display what
			unset($_SESSION['retrievePass']);
		}
		if (isset($_SESSION['erase'])) {
			echo $_SESSION['erase']['m'];//message
			$js=$_SESSION['erase']['d'];//display what
			unset($_SESSION['erase']);
		}
		if ($js) {
			echo '
			<script type="text/javascript">
			setTimeout(function(){
				'.(strstr($js,'s')?'document.getElementById("password_success").style.display="none";':'').'
				'.(strstr($js,'e')?'document.getElementById("password_error").style.display="none";':'').'
			},5000);
			</script>';
		}
	}
}